"use strict";
/**
 * Created by rburson on 3/21/16.
 */
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
/*
 *  -------- Start react-widgets setup -----------
 *  The following are all the requirements for using the react-widgets dateTime components
 *  globalize is required and a configured 'instance' must be provided to react-widgets
 *  Note: These all use the older, commonjs-style object export
 *  On the bright side, globalize is very comprehensive, so supporting different locales and formats
 *  of numbers, currency, and dates in the future should be easier
 */
var react_widgets_1 = require("react-widgets");
var Globalize = require("globalize");
//import the localization data
var cldrDataSubtags = require("cldr-data/supplemental/likelySubtags");
var cldrDataTime = require("cldr-data/supplemental/timeData");
var cldrDataWeek = require("cldr-data/supplemental/weekData");
//English
var cldrDataNumSystems = require("cldr-data/supplemental/numberingSystems");
var cldrDataGreg = require("cldr-data/main/en/ca-gregorian");
var cldrDataTimeZoneNames = require("cldr-data/main/en/timeZoneNames");
var cldrDataDate = require("cldr-data/main/en/dateFields");
var cldrDataNumber = require("cldr-data/main/en/numbers");
//German
var cldrDataGregDE = require("cldr-data/main/de/ca-gregorian");
var cldrDataTimeZoneNamesDE = require("cldr-data/main/de/timeZoneNames");
var cldrDataDateDE = require("cldr-data/main/de/dateFields");
var cldrDataNumberDE = require("cldr-data/main/de/numbers");
Globalize.load(cldrDataDate, cldrDataGreg, cldrDataNumber, cldrDataGregDE, cldrDataTimeZoneNamesDE, cldrDataDateDE, cldrDataNumberDE, cldrDataTime, cldrDataWeek, cldrDataSubtags, cldrDataTimeZoneNames, cldrDataNumSystems);
//Set the locale here
Globalize.locale('en');
var globalizeLocalizer = require("react-widgets-globalize");
globalizeLocalizer(Globalize);
/*
 *  -------- End react-widgets setup ----------
 */
var moment = require("moment");
exports.CvCellValueDefMixin = {
    _applyHeaderStyle: function (component, cellValueDef) {
        var answer = component;
        if (cellValueDef.isHeading1Style) {
            answer = React.createElement("h1", null, component);
        }
        else if (cellValueDef.isHeading2Style) {
            answer = React.createElement("h2", null, component);
        }
        else if (cellValueDef.isHeading3Style) {
            answer = React.createElement("h3", null, component);
        }
        else if (cellValueDef.isHeading4Style) {
            answer = React.createElement("h4", null, component);
        }
        return answer;
    },
    cellValueDef: function (nextProps) {
        return (nextProps && nextProps.cellValueDef) || this.props.cellValueDef;
    },
    detailsCallback: function (nextProps) {
        return (nextProps && nextProps.detailsCallback) || this.props.detailsCallback;
    },
    detailsContext: function (nextProps) {
        return (nextProps && nextProps.detailsContext) || this.props.detailsContext || this.firstInScope(catavolt_sdk_1.DetailsContext);
    },
    getChildContext: function () {
        var ctx = this.getDefaultChildContext();
        ctx.cvContext.scopeCtx.scopeObj = this.cellValueDef();
        return ctx;
    }
};
/*
 ***************************************************
 * Render an CellValueDef
 ***************************************************
 */
exports.CvCellValueDef = React.createClass({
    mixins: [catreact_1.CvBaseMixin, exports.CvCellValueDefMixin],
    render: function () {
        if (this.props.renderer) {
            return this.props.renderer(this.getChildContext().cvContext);
        }
        else {
            var detailsContext = this.detailsContext();
            var cellValueDef = this.cellValueDef();
            var component = null;
            if (cellValueDef) {
                if (cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef) {
                    var prop = detailsContext.entityRec.propAtName(cellValueDef.propertyName);
                    var hasFocus = detailsContext.detailsDef.focusPropName ?
                        cellValueDef.propertyName == detailsContext.detailsDef.focusPropName : false;
                    var styleInfo = catreact_html_1.CvDataAnno.generateStyleInfo(prop);
                    component = React.createElement(catreact_html_1.CvDataAnno, { dataAnnoStyle: styleInfo, paneContext: detailsContext, wrapperElem: this.props.wrapperElem, wrapperElemProps: this.props.wrapperElemProps },
                        React.createElement(exports.CvAttributeCellValueDef, { detailsContext: detailsContext, detailsCallback: this.detailsCallback(), cellValueDef: this.cellValueDef(), imageProducers: this.props.imageProducers, imageReadOnly: this.props.imageReadOnly, overrideDefaultValue: this.props.overrideDefaultValue, overrideText: styleInfo.overrideText, valueChangeListener: this.props.valueChangeListener, hasFocus: hasFocus }));
                    return component;
                }
                else if (cellValueDef instanceof catavolt_sdk_1.LabelCellValueDef) {
                    component = React.createElement("span", { className: "cv-label-cell-def" }, cellValueDef.value);
                    // Apply the heading style
                    component = this._applyHeaderStyle(component, cellValueDef);
                }
                else if (cellValueDef instanceof catavolt_sdk_1.ForcedLineCellValueDef) {
                    // Display a hidden M to make sure this line takes up some vertical space.
                    component = React.createElement("span", { className: "cv-forced-line-cell-def", style: { visibility: "hidden" } }, 'M');
                }
                else if (cellValueDef instanceof catavolt_sdk_1.TabCellValueDef) {
                    component = React.createElement("span", { className: "cv-tab-cell-def" });
                }
                else if (cellValueDef instanceof catavolt_sdk_1.SubstitutionCellValueDef) {
                    component =
                        React.createElement("span", { className: "cv-sub-cell-def" }, cellValueDef.value);
                }
                else {
                    component = React.createElement("span", null);
                }
            }
            var props = catavolt_sdk_1.ObjUtil.addAllProps(this.props.wrapperElemProps, {});
            return React.createElement(this.props.wrapperElem, props, component);
        }
    }
});
var cv_no_selection_value = 'cv_no_selection_value';
exports.CvAttributeCellValueDef = React.createClass({
    mixins: [catreact_1.CvBaseMixin, exports.CvCellValueDefMixin],
    componentWillMount: function () {
        this.refresh();
    },
    componentWillReceiveProps: function (nextProps) {
        this.refresh(nextProps);
    },
    getDefaultProps: function () {
        return { cellValueDef: null, detailsContext: null, detailsCallback: null, overrideText: null,
            overrideDefaultValue: null, valueChangeListener: null, classSelector: null, hasFocus: false };
    },
    getInitialState: function () {
        return { availableValues: null, imageExistenceState: null };
    },
    render: function () {
        var _this = this;
        var csf = this.props.classSelector ? this.props.classSelector : function (propDef, defaultClass) { return defaultClass; };
        var inlineStyle = this.props.inlineStyle;
        if (this.props.renderer) {
            return this.props.renderer(this.getChildContext().cvContext);
        }
        else {
            var detailsContext = this.detailsContext();
            var cellValueDef = this.cellValueDef();
            var overrideDefaultValue = this.props.overrideDefaultValue;
            var focusFn = function (ref) { if (ref && _this.props.hasFocus)
                ref.focus(); };
            var component = null;
            if (cellValueDef && cellValueDef.propertyName) {
                if (!detailsContext.isReadModeFor(cellValueDef.propertyName) && !this.props.overrideText) {
                    var prop_1 = detailsContext.buffer.propAtName(cellValueDef.propertyName);
                    var propDef_1 = detailsContext.entityRecDef.propDefAtName(cellValueDef.propertyName);
                    if (prop_1) {
                        /*** Combobox ***/
                        if (cellValueDef.isComboBoxEntryMethod) {
                            if (this.state.availableValues) {
                                //this is not applied atm
                                var cn = csf(propDef_1, "form-control cv-cell-def-select-box");
                                var data = this._assignData(overrideDefaultValue, prop_1.value, propDef_1, this.state.availableValues);
                                component = React.createElement(react_widgets_1.DropdownList, { defaultValue: data.selected, data: data.values, textField: (function (item) { return _this._getOptionDisplayValue(item, propDef_1); }), onChange: this._propChange.bind(this, prop_1.name, propDef_1), ref: focusFn });
                            }
                            /*** Dropdown ***/
                        }
                        else if (cellValueDef.isDropDownEntryMethod) {
                            if (this.state.availableValues) {
                                if (propDef_1.isListType) {
                                    component = React.createElement(react_widgets_1.Multiselect, { defaultValue: overrideDefaultValue ? overrideDefaultValue : this._createDisplayValueList(prop_1.value, propDef_1), data: this._createDisplayValueList(this.state.availableValues, propDef_1), textField: 'display', placeholder: "No Items Selected", onChange: this._listChange.bind(this, prop_1.name, propDef_1), ref: focusFn });
                                }
                                else {
                                    //this is not applied atm
                                    var cn = csf(propDef_1, "form-control cv-cell-def-select-box");
                                    var data = this._assignData(overrideDefaultValue, prop_1.value, propDef_1, this.state.availableValues);
                                    component = React.createElement(react_widgets_1.DropdownList, { defaultValue: data.selected, data: data.values, textField: (function (item) { return _this._getOptionDisplayValue(item, propDef_1); }), onChange: this._propChange.bind(this, prop_1.name, propDef_1), ref: focusFn });
                                }
                            }
                            /*** Icon chooser ***/
                        }
                        else if (cellValueDef.isIconEntryMethod) {
                            if (this.state.availableValues) {
                                var data = this._assignData(null, prop_1.value, propDef_1, this.state.availableValues);
                                component = React.createElement(react_widgets_1.DropdownList, { defaultValue: data.selected, data: data.values, placeholder: "No Items Selected", valueComponent: this._newIconRenderer("cv-icon-chooser-value"), itemComponent: this._newIconRenderer("cv-icon-chooser-item"), onChange: this._propChangeIcon.bind(this, prop_1.name, propDef_1), ref: focusFn });
                            }
                        }
                        else {
                            /*** Binary ***/
                            if (detailsContext.isBinary(cellValueDef)) {
                                var imageActions = this.props.imageProducers == null ? null :
                                    this.props.imageProducers.filter(function (ip) {
                                        return (_this.state.imageExistenceState == catreact_1.CvImageExistenceState.Present && ip.includeWhenImageisPresent)
                                            || (_this.state.imageExistenceState == catreact_1.CvImageExistenceState.Missing && ip.includeWhenImageIsMissing)
                                            || (_this.state.imageExistenceState == catreact_1.CvImageExistenceState.Deleted && ip.includeWhenImageIsDeleted);
                                    }).map(function (w) {
                                        var ip = w;
                                        var launchPick = function () {
                                            var input = _this.refs["inputFileRef"];
                                            input.click();
                                        };
                                        var a = new catreact_1.CvValueAdapter();
                                        var f = _this.setImageFromDataUrl.bind(_this, prop_1.name, propDef_1, launchPick);
                                        a.subscribe(function (v) { f(v); });
                                        return { callback: function () { ip.prodImageCB(a.createValueListener()); },
                                            buttonClassName: ip.buttonClassName };
                                    });
                                var style = this.props.inlineStyle ? this.props.inlineStyle : (this.props.imageStyle ? this.props.imageStyle : this.props.style);
                                var readOnly = (this.props.imageReadOnly === undefined) || (this.props.imageReadOnly === null) ? false : this.props.imageReadOnly;
                                component = React.createElement("div", null,
                                    React.createElement("input", { type: "file", onChange: this._fileChange.bind(this, prop_1.name, propDef_1), ref: "inputFileRef", style: { display: "none" } }),
                                    React.createElement(catreact_html_1.CvHtmlProp, { style: style, propName: cellValueDef.propertyName, entityRec: detailsContext.entityRec, imageActions: imageActions, imageReadOnly: readOnly, hasFocus: this.props.hasFocus }));
                            }
                            else {
                                /*** Boolean ***/
                                if (propDef_1.isBooleanType) {
                                    component = React.createElement("input", { type: "checkbox", defaultChecked: overrideDefaultValue != null ? overrideDefaultValue : prop_1.value, onChange: this._checkboxChange.bind(this, prop_1.name, propDef_1), ref: focusFn });
                                    /*** Datetime ***/
                                }
                                else if (propDef_1.isDateTimeType) {
                                    var formatter = Globalize.dateFormatter({ datetime: "medium" });
                                    var editFormatter = Globalize.dateFormatter({ datetime: "short" });
                                    var timeFormatter = Globalize.dateFormatter({ time: "medium" });
                                    component = React.createElement(react_widgets_1.DateTimePicker, { defaultValue: overrideDefaultValue ? overrideDefaultValue : prop_1.value, onChange: this._dateChange.bind(this, prop_1.name, propDef_1), calendar: true, time: true, format: formatter, editFormat: editFormatter, timeFormat: timeFormatter, parse: function (str) { return moment(str).toDate(); }, ref: focusFn });
                                    /*** Date ***/
                                }
                                else if (propDef_1.isDateType) {
                                    var formatter = Globalize.dateFormatter({ date: "long" });
                                    var editFormatter = Globalize.dateFormatter({ date: "short" });
                                    component = React.createElement(react_widgets_1.DateTimePicker, { defaultValue: overrideDefaultValue ? overrideDefaultValue : prop_1.value, onChange: this._dateChange.bind(this, prop_1.name, propDef_1), calendar: true, time: false, format: formatter, editFormat: editFormatter, parse: function (strDate) { return moment(strDate).toDate(); }, ref: focusFn });
                                    /*** Time ***/
                                }
                                else if (propDef_1.isTimeType) {
                                    var formatter = Globalize.dateFormatter({ time: "medium" });
                                    var editFormatter = Globalize.dateFormatter({ time: "medium" });
                                    component = React.createElement(react_widgets_1.DateTimePicker, { defaultValue: overrideDefaultValue ? overrideDefaultValue : (prop_1.value ? prop_1.value.toDateValue() : null), onChange: this._dateChange.bind(this, prop_1.name, propDef_1), calendar: false, time: true, format: formatter, timeFormat: editFormatter, parse: function (strTime) { return moment("2000-01-01 " + strTime, ["YYYY-MM-DD h:m:s:a", "YYYY-MM-DD H:m:s"]).toDate(); }, ref: focusFn });
                                }
                                else if (propDef_1.isFileAttachment) {
                                    component = React.createElement("input", { style: inlineStyle, type: "file", onChange: this._fileChange.bind(this, prop_1.name, propDef_1), ref: focusFn });
                                    /*** Text ***/
                                }
                                else if (propDef_1.isTextBlock) {
                                    var cn = csf(propDef_1, "form-control");
                                    component = React.createElement("textarea", { id: cellValueDef.propertyName, className: cn, style: inlineStyle, onBlur: function (e) { return _this._propChange(prop_1.name, propDef_1, e.currentTarget.value); }, defaultValue: prop_1 ? prop_1.value : "", ref: focusFn });
                                }
                                else {
                                    var cn = csf(propDef_1, "form-control");
                                    component = React.createElement("input", { type: "text", className: cn, style: inlineStyle, onBlur: function (e) { return _this._propChange(prop_1.name, propDef_1, e.currentTarget.value); }, id: cellValueDef.propertyName, defaultValue: overrideDefaultValue ? overrideDefaultValue : catavolt_sdk_1.PropFormatter.formatForWrite(prop_1, propDef_1), ref: focusFn });
                                }
                            }
                        }
                    }
                }
                else {
                    var propDef = detailsContext.entityRecDef.propDefAtName(cellValueDef.propertyName);
                    var optionalProps = propDef && propDef.isTextBlock ? { className: "cv-text-area" } : {};
                    if (propDef.isURLType) {
                        var prop = detailsContext.buffer.propAtName(cellValueDef.propertyName);
                        var url = catavolt_sdk_1.PropFormatter.formatForRead(prop, propDef);
                        // if (url && url.indexOf("http") !== 0 ) {       THIS WOULD PROHIBIT mailto:....
                        //     url = "https://" + url;
                        // }
                        component = React.createElement("a", { href: url, target: "_blank" }, url);
                    }
                    else {
                        component = React.createElement(catreact_html_1.CvHtmlProp, __assign({}, optionalProps, { propName: cellValueDef.propertyName, entityRec: detailsContext.entityRec, overrideValue: this.props.overrideText, style: inlineStyle, imageReadOnly: true }));
                    }
                }
            }
            // Apply the heading style
            component = this._applyHeaderStyle(component, cellValueDef);
            return component;
        }
    },
    refresh: function (nextProps) {
        var _this = this;
        var cellValueDef = this.cellValueDef(nextProps);
        var detailsContext = this.detailsContext(nextProps);
        var prop = detailsContext.buffer.propAtName(cellValueDef.propertyName);
        var propDef = detailsContext.entityRecDef.propDefAtName(cellValueDef.propertyName);
        if (!detailsContext.isReadModeFor(cellValueDef.propertyName)) {
            if (cellValueDef.propertyName && (cellValueDef.isComboBoxEntryMethod || cellValueDef.isDropDownEntryMethod || cellValueDef.isIconEntryMethod)) {
                detailsContext.getAvailableValues(cellValueDef.propertyName).onComplete(function (valueTry) {
                    if (valueTry.isSuccess) {
                        _this.setState({ availableValues: valueTry.success });
                    }
                    else {
                        var event_1 = {
                            type: catreact_1.CvEventType.MESSAGE,
                            eventObj: {
                                message: 'Could not get available values for property: ' + cellValueDef.propertyName,
                                messageObj: valueTry.failure,
                                type: catreact_1.CvMessageType.ERROR
                            }
                        };
                        _this.eventRegistry().publish(event_1, false);
                    }
                });
                // If not already done, set the image-existence-state.
            }
            else if (propDef.isBinaryType && (!this.state.imageExistenceState) && detailsContext.isFirstReadComplete) {
                if (prop && prop.value) {
                    this.setState({ imageExistenceState: catreact_1.CvImageExistenceState.Present });
                }
                else {
                    this.setState({ imageExistenceState: catreact_1.CvImageExistenceState.Missing });
                }
            }
        }
    },
    setImageFromDataUrl: function (propName, propDef, launchPick, imagePackage) {
        var _this = this;
        var imagePresent = this.state.imageExistenceState === catreact_1.CvImageExistenceState.Present;
        var futureUndoUrl = (imagePresent && this.state.selectedImageSrc) ? this.state.selectedImageSrc : null;
        var dataUrl = null;
        var needToSetImage = false;
        // If this is an undo request, and there is no imageUndoData in state, then we should undo with the original
        // value which requires an async read.
        if (imagePackage.isPick()) {
            launchPick();
        }
        else if (imagePackage.isUndo()) {
            if (this.state.imageUndoData) {
                // Set the new value in the model and state.
                dataUrl = this.state.imageUndoData;
                needToSetImage = true;
            }
            else {
                // If there is no undo data, read the binary value from the SDK.
                var detailsContext = this.detailsContext();
                var cellValueDef = this.cellValueDef();
                var prop = detailsContext.buffer.propAtName(cellValueDef.propertyName);
                detailsContext.binaryAt(cellValueDef.propertyName, detailsContext.buffer.before).onComplete(function (binaryTry) {
                    if (binaryTry.isSuccess) {
                        if (_this.isMounted()) {
                            _this.setState({ imageUndoData: binaryTry.success.toUrl() });
                            _this.setImageFromDataUrl(propName, propDef, launchPick, new catreact_1.CvImagePackageUrl(binaryTry.success.toUrl()));
                        }
                    }
                });
            }
        }
        else if (imagePackage.isUrl()) {
            // If the value is being set, take the current value and add to the undo state for a future undo.
            dataUrl = imagePackage.url;
            this.setState({ imageUndoData: futureUndoUrl });
            needToSetImage = true;
        }
        else if (imagePackage.isDelete()) {
            dataUrl = null;
            this.setState({ imageUndoData: futureUndoUrl });
            needToSetImage = true;
        }
        if (needToSetImage) {
            if (this.props.valueChangeListener)
                this.props.valueChangeListener(propName, propDef, dataUrl);
            this.detailsCallback().setBinaryPropWithDataUrl(propName, dataUrl);
            this.setState({ selectedImageSrc: dataUrl,
                imageExistenceState: (dataUrl ? catreact_1.CvImageExistenceState.Present : catreact_1.CvImageExistenceState.Deleted) });
        }
    },
    _createDisplayValueList: function (values, propDef) {
        var _this = this;
        if (values && values.length > 0) {
            return values.map(function (value) { return _this._createDisplayValueObject(value, propDef); });
        }
        else {
            return null;
        }
    },
    _createDisplayValueObject: function (optionValue, propDef) {
        return { display: this._getOptionDisplayValue(optionValue, propDef), value: optionValue };
    },
    _getOptionDisplayValue: function (optionValue, propDef) {
        if (optionValue === cv_no_selection_value) {
            return 'No Selection';
        }
        else if (optionValue instanceof catavolt_sdk_1.CodeRef) {
            return optionValue.description;
        }
        else if (optionValue instanceof catavolt_sdk_1.ObjectRef) {
            return optionValue.description;
        }
        else {
            return catavolt_sdk_1.PropFormatter.toString(optionValue, propDef);
        }
    },
    _assignData: function (override, value, propDef, values) {
        var selected = override ? override :
            this._findPropValueInList(value, propDef, this.state.availableValues);
        var answer = null;
        if (selected == null && (value != null)) {
            values.splice(0, 0, value);
            answer = { selected: value, values: values };
        }
        else if (selected == null) {
            answer = { selected: cv_no_selection_value, values: values };
        }
        else {
            answer = { selected: selected, values: values };
        }
        return answer;
    },
    _findPropValueInList: function (optionValue, propDef, optionValues) {
        var result = catavolt_sdk_1.ArrayUtil.find(optionValues, function (item) { return catavolt_sdk_1.Prop.identity(optionValue, propDef) == catavolt_sdk_1.Prop.identity(item, propDef); });
        return result; //  ? result : cv_no_selection_value;
    },
    _listChange: function (propName, propDef, list) {
        var value = list.map(function (v) { return v.value; });
        if (this.props.valueChangeListener)
            this.props.valueChangeListener(propName, propDef, value);
        this.detailsCallback().setPropValue(propName, value);
    },
    _propChange: function (propName, propDef, selectedValue) {
        var value = selectedValue === cv_no_selection_value ? null : selectedValue;
        if (value == '' || value === undefined) {
            value = null;
        }
        if (this.props.valueChangeListener)
            this.props.valueChangeListener(propName, propDef, value);
        this.detailsCallback().setPropValue(propName, value);
    },
    _propChangeIcon: function (propName, propDef, cr) {
        if (this.props.valueChangeListener)
            this.props.valueChangeListener(propName, propDef, cr);
        this.detailsCallback().setPropValue(propName, cr);
    },
    _dateChange: function (propName, propDef, dateValue, stringValue) {
        if (this.props.valueChangeListener)
            this.props.valueChangeListener(propName, propDef, dateValue);
        if (dateValue) {
            if (propDef.isDateTimeType || propDef.isDateType) {
                this.detailsCallback().setPropValue(propName, dateValue);
            }
            else if (propDef.isTimeType) {
                this.detailsCallback().setPropValue(propName, catavolt_sdk_1.TimeValue.fromDateValue(dateValue));
            }
        }
        else {
            this.detailsCallback().setPropValue(propName, null);
        }
    },
    _checkboxChange: function (propName, propDef, e) {
        if (e.currentTarget.checked) {
            if (this.props.valueChangeListener)
                this.props.valueChangeListener(propName, propDef, true);
            this.detailsCallback().setPropValue(propName, true);
        }
        else {
            if (this.props.valueChangeListener)
                this.props.valueChangeListener(propName, propDef, false);
            this.detailsCallback().setPropValue(propName, false);
        }
    },
    _fileChange: function (propName, propDef, e) {
        var _this = this;
        if (e.currentTarget.files) {
            var files = e.currentTarget.files;
            if (files.length > 0) {
                if (this.props.valueChangeListener)
                    this.props.valueChangeListener(propName, propDef, files[0]);
                //Attachment
                if (propDef.isFileAttachment) {
                    this.detailsCallback().setPropValue(propName, new catavolt_sdk_1.Attachment(files[0].name, files[0]));
                }
                else {
                    //Binary
                    var fr = new FileReader();
                    fr.onload = function (e) {
                        var dataUrl = e.target.result;
                        _this.detailsCallback().setBinaryPropWithDataUrl(propName, dataUrl);
                        _this.setState({ selectedImageSrc: dataUrl, imageExistenceState: catreact_1.CvImageExistenceState.Present });
                    };
                    fr.readAsDataURL(files[0]);
                }
            }
        }
    },
    _newIconRenderer: function (className) {
        return React.createClass({
            render: function () {
                var cr = this.props.item;
                return React.createElement("div", { className: className },
                    React.createElement("img", { src: this._findPath(cr.description) }),
                    React.createElement("span", null, cr.code));
            },
            _findPath: function (desc) {
                if (desc) {
                    var i = desc.indexOf(":");
                    if (i > -1 && (i < desc.length - 1)) {
                        var answer = desc.substr(i + 1);
                    }
                }
                return answer;
            }
        });
    }
});
