"use strict";
/**
 * Created by rburson on 3/18/16.
 */
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
var CvSignaturePopup_1 = require("./CvSignaturePopup");
var CvImage_1 = require("./CvImage");
var FORCED_LINE_DEF = new catavolt_sdk_1.ForcedLineCellValueDef();
/**
 * Renders a Details Panel, styled by CSS
 */
exports.CvDetailsPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    render: function () {
        var _this = this;
        return React.createElement(catreact_1.CvDetailsPane, __assign({}, this.props, { detailsRenderer: function (cvContext, record, detailsCallback) {
                var detailsContext = cvContext.scopeCtx.scopeObj;
                return (React.createElement(catreact_1.CvRecord, { entityRec: record, renderer: function (cvContext) {
                        return (React.createElement("div", { className: "cv-component-container cv-detail-container" },
                            (function () {
                                if (detailsContext.detailsDef.editable) {
                                    if (detailsContext.isReadMode) {
                                        return React.createElement("div", { className: "cv-component-toolbar" },
                                            React.createElement(exports.CvDetailsPanelControls, { onRefresh: _this._refresh.bind(_this, detailsCallback), onEdit: _this._openWriteMode.bind(_this, detailsCallback) }));
                                    }
                                    else if (detailsContext.isWriteMode) {
                                        var cancelButtonText = detailsContext.detailsDef.cancelButtonText;
                                        var commitButtonText = detailsContext.detailsDef.commitButtonText;
                                        return React.createElement("div", { className: "cv-component-toolbar" },
                                            React.createElement(exports.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, detailsCallback), onCommit: _this._save.bind(_this, detailsCallback) }));
                                    }
                                }
                                else {
                                    return null;
                                }
                            })(),
                            React.createElement("div", { className: "cv-component-body" },
                                React.createElement("div", { className: "cv-component-scroll" },
                                    React.createElement("table", { className: "table table-striped" },
                                        React.createElement("tbody", null, _this._layoutDetailsPane(detailsContext, record, detailsCallback))))),
                            (function () {
                                var cancelButtonText = detailsContext.detailsDef.cancelButtonText;
                                var commitButtonText = detailsContext.detailsDef.commitButtonText;
                                return (detailsContext.detailsDef.editable && detailsContext.isWriteMode) ?
                                    React.createElement("div", { className: "cv-component-toolbar cv-detail-controls-lower" },
                                        React.createElement(exports.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, detailsCallback), onCommit: _this._save.bind(_this, detailsCallback) })) : null;
                            })()));
                    } }));
            } }));
    },
    _layoutDetailsPane: function (detailsContext, record, detailsCallback) {
        var _this = this;
        var renderedDetailRows = [];
        if (detailsContext) {
            var outterColumns_1 = detailsContext.detailsDef.rows.reduce(function (prv1, cellDefRow) {
                return Math.max(prv1, cellDefRow.length);
            }, 0);
            detailsContext.detailsDef.rows.forEach(function (cellDefRow, index) {
                renderedDetailRows.push(React.createElement(catreact_html_1.CvDataAnno, { entityRec: record, paneContext: detailsContext, wrapperElem: "tr", wrapperElemProps: { className: "cv-cell-def-row" }, key: index }, (function () {
                    return cellDefRow.map(function (cellDef, index) {
                        var columnsInThisRow = cellDefRow.length;
                        var colspan = ((index + 1) == columnsInThisRow) ? outterColumns_1 - columnsInThisRow + 1 : 1;
                        var answer = null;
                        if (cellDef.values.length <= 1) {
                            var cellValueDef = (cellDef.values.length == 1) ? cellDef.values[0] : FORCED_LINE_DEF;
                            answer = React.createElement(catreact_html_1.CvCellValueDef, { detailsContext: detailsContext, detailsCallback: detailsCallback, cellValueDef: cellValueDef, wrapperElem: "td", wrapperElemProps: { className: 'cv-cell-def-col', colSpan: colspan }, key: index, imageProducers: _this._buildImageProducers(detailsContext, cellValueDef) });
                        }
                        else {
                            // If there are more than one cellDef.value they should be built in a sub-table to keep the parent column in tact.
                            answer = React.createElement("td", { colSpan: colspan },
                                React.createElement("table", { className: "table", style: { background: "transparent" } },
                                    React.createElement("tr", null, (function () {
                                        return cellDef.values.map(function (cellValueDef, i2) {
                                            return React.createElement(catreact_html_1.CvCellValueDef, { detailsContext: detailsContext, detailsCallback: detailsCallback, cellValueDef: cellValueDef, wrapperElem: "td", wrapperElemProps: { className: 'cv-cell-def-col' }, key: i2, imageProducers: _this._buildImageProducers(detailsContext, cellValueDef) });
                                        });
                                    })())));
                        }
                        return answer;
                    });
                })()));
            });
        }
        return renderedDetailRows;
    },
    _buildImageProducers: function (detailsContext, cellValueDef) {
        var imageProducers = null;
        if (!this._isReadModeFor(detailsContext, cellValueDef)) {
            if (cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef && detailsContext.isSignature(cellValueDef)) {
                imageProducers = [
                    {
                        prodImageCB: function (listener) {
                            CvSignaturePopup_1.openSignaturePopup(listener);
                        },
                        buttonClassName: CvImage_1.CvImageDefaultSignatureButtonClass, includeWhenImageisPresent: true, includeWhenImageIsMissing: true,
                        includeWhenImageIsDeleted: true
                    }
                ];
            }
            else {
                imageProducers = [
                    {
                        // Pick a new file with the file chooser.
                        prodImageCB: function (listener) {
                            listener(new catreact_1.CvImagePackagePick());
                        },
                        buttonClassName: catreact_html_1.CvImageDefaultAddButtonClass,
                        includeWhenImageisPresent: true,
                        includeWhenImageIsMissing: true,
                        includeWhenImageIsDeleted: true
                    },
                    {
                        // Delete existing image
                        prodImageCB: function (listener) {
                            listener(new catreact_1.CvImagePackageDelete());
                        },
                        buttonClassName: catreact_html_1.CvImageDefaultRemoveButtonClass,
                        includeWhenImageisPresent: true,
                        includeWhenImageIsMissing: false,
                        includeWhenImageIsDeleted: false
                    },
                    {
                        // Undo previous delete image
                        prodImageCB: function (listener) {
                            listener(new catreact_1.CvImagePackageUndo());
                        },
                        buttonClassName: catreact_html_1.CvImageDefaultUndoButtonClass,
                        includeWhenImageisPresent: false,
                        includeWhenImageIsMissing: false,
                        includeWhenImageIsDeleted: true
                    }
                ];
            }
        }
        return imageProducers;
    },
    _isReadModeFor: function (detailsContext, cellValueDef) {
        return cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef && detailsContext.isReadModeFor(cellValueDef.propertyName);
    },
    _openWriteMode: function (detailsCallback) {
        detailsCallback.openWriteMode(function (success, error) {
        });
    },
    _openReadMode: function (detailsCallback) {
        detailsCallback.openReadMode(function (success, error) {
        });
    },
    _refresh: function (detailsCallback) {
        detailsCallback.refresh();
    },
    _save: function (detailsCallback) {
        detailsCallback.saveChanges(function (success, error) {
        });
    }
});
exports.CvDetailsPanelCommitCancelControls = React.createClass({
    render: function () {
        var cancelButtonText = (_a = this.props, _a.cancelButtonText), commitButtonText = _a.commitButtonText, onCancel = _a.onCancel, onCommit = _a.onCommit;
        return React.createElement("div", { className: "text-right" },
            React.createElement("button", { className: "btn btn-default", onClick: onCancel },
                cancelButtonText ? React.createElement("span", { style: { marginRight: '10px' } }, cancelButtonText) : null,
                React.createElement("span", { className: "glyphicon glyphicon-remove", "aria-hidden": "true" })),
            React.createElement("button", { className: "btn btn-default", onClick: onCommit },
                commitButtonText ? React.createElement("span", { style: { marginRight: '10px' } }, commitButtonText) : null,
                React.createElement("span", { className: "glyphicon glyphicon-ok", "aria-hidden": "true" })));
        var _a;
    }
});
exports.CvDetailsPanelControls = React.createClass({
    render: function () {
        return React.createElement("div", { className: "text-right" },
            React.createElement("button", { className: "btn btn-default", onClick: this.props.onRefresh },
                React.createElement("span", { className: "glyphicon glyphicon-refresh", "aria-hidden": "true" })),
            React.createElement("button", { className: "btn btn-default", onClick: this.props.onEdit },
                React.createElement("span", { className: "glyphicon glyphicon-edit", "aria-hidden": "true" })));
    }
});
