"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by rburson on 3/18/16.
 */
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
/*
 ***************************************************
 * Render a ListContext
 ***************************************************
 */
exports.CvListPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    getDefaultProps: function () {
        return {
            paneRef: null,
            formContext: null,
            listContext: null,
            navigationListeners: [],
            selectionListener: null,
            stateChangeListeners: [],
            actionProvider: null,
            searchable: false,
        };
    },
    getInitialState: function () {
        return { selectedItems: [], searchNavResult: null };
    },
    render: function () {
        var _this = this;
        /* We can't do ES7 style rest destructuring in Typescript yet... */
        var listPaneProps = {
            paneRef: this.props.paneRef,
            formContext: this.props.formContext,
            queryContext: this.props.listContext,
            stateChangeListeners: this.props.stateChangeListeners,
            actionListeners: this.props.actionListeners,
            actionProvider: this.props.actionProvider
        };
        return (React.createElement(catreact_1.CvListPane, __assign({}, listPaneProps, { recordPageSize: 50, queryRenderer: function (cvContext, callback) {
                var listContext = cvContext.scopeCtx.scopeObj;
                return (React.createElement("div", { className: "cv-list-container" },
                    (function () {
                        return _this.props.searchable ?
                            React.createElement(catreact_1.CvAction, { actionId: '#search', fireOnLoad: function (success, error) { }, paneContext: listContext, navigationListeners: [function (event) {
                                        _this.setState({ searchNavResult: event.eventObj });
                                    }] }) : null;
                    })(),
                    React.createElement("div", { className: "text-right" },
                        React.createElement("button", { className: "btn btn-default", onClick: callback.refresh },
                            React.createElement("span", { className: "glyphicon glyphicon-refresh", "aria-hidden": "true" })),
                        (function () {
                            return _this.props.searchable ?
                                React.createElement(catreact_1.CvAction, { actionId: '#search', paneContext: listContext, navigationListeners: _this.props.navigationListeners, actionListeners: _this.props.actionListeners, stateChangeListeners: _this.props.stateChangeListeners, renderer: function (cvContext, callback) {
                                        return React.createElement("button", { className: "btn btn-default", onClick: function () { callback.fireAction(); } },
                                            React.createElement("span", { className: "glyphicon glyphicon-search", "aria-hidden": "true" }));
                                    } }) : null;
                        })()),
                    React.createElement("div", { className: "cv-list-scrollpane", onScroll: _this._magicScroll.bind(_this, callback) },
                        React.createElement("table", { className: "table table-striped cv-table" },
                            React.createElement(exports.CvListTableHeader, { searchNavResult: _this.state.searchNavResult, listContext: listContext }),
                            React.createElement(catreact_1.CvRecordList, { queryContext: listContext, wrapperElemName: 'tbody', rowRenderer: function (cvContext, record) {
                                    return (React.createElement(catreact_1.CvRecord, { entityRec: record, key: record.objectId, renderer: function (cvContext) {
                                            var rowProps = _this._isSelected(record.objectId) ? { className: 'cv-selected-row' } : {};
                                            rowProps['onClick'] = _this._itemClicked.bind(_this, record.objectId);
                                            return (React.createElement(catreact_html_1.CvDataAnno, { entityRec: record, paneContext: listContext, wrapperElem: "tr", wrapperElemProps: rowProps },
                                                React.createElement("td", { className: "cv-list-cell" }),
                                                listContext.listDef.activeColumnDefs.map(function (columnDef) {
                                                    var name = columnDef.name;
                                                    //select "this record" so that the action can find the target via the selectionProvider
                                                    var selectionAdapter = new catreact_1.CvValueAdapter();
                                                    selectionAdapter.createValueListener()([record.objectId]);
                                                    var prop = record.propAtName(name);
                                                    return (React.createElement(catreact_1.CvAction, { actionId: listContext.listDef.defaultActionId, paneContext: listContext, navigationListeners: _this.props.navigationListeners, actionListeners: _this.props.actionListeners, stateChangeListeners: _this.props.stateChangeListeners, selectionProvider: selectionAdapter, key: prop.name, renderer: function (cvContext, callback) {
                                                            var styleInfo = catreact_html_1.CvDataAnno.generateStyleInfo(prop);
                                                            var cellStyle = 'cv-list-cell cv-target ' + exports.CvListColumnHeader.classForColumnDef(columnDef);
                                                            return (React.createElement(catreact_html_1.CvDataAnno, { dataAnnoStyle: styleInfo, paneContext: listContext, wrapperElem: "td", wrapperElemProps: { className: cellStyle } },
                                                                React.createElement(catreact_html_1.CvHtmlProp, { propName: prop.name, entityRec: record, paneContext: listContext, imageClassName: "cv-image-list-item-max-size", wrapperElemProps: { onClick: function (e) {
                                                                            e.preventDefault();
                                                                            e.stopPropagation();
                                                                            callback.fireAction();
                                                                        }
                                                                    }, overrideValue: styleInfo.overrideText })));
                                                        } }));
                                                })));
                                        } }));
                                } })))));
            } })));
    },
    _isSelected: function (oid) {
        return this.state.selectedItems.indexOf(oid) > -1;
    },
    _itemClicked: function (oid) {
        var selectedItems = this.state.selectedItems;
        var index = selectedItems.indexOf(oid);
        if (index > -1) {
            selectedItems.splice(index, 1);
        }
        else {
            selectedItems.push(oid);
        }
        this.setState({ selectedItems: selectedItems });
        if (this.props.selectionListener)
            this.props.selectionListener(selectedItems);
    },
    _magicScroll: function (callback, e) {
        var elem = e.currentTarget;
        if (elem.scrollTop / (elem.scrollHeight - elem.clientHeight) > .95) {
            if (callback.hasMoreForward()) {
                callback.pageForward(function (num) {
                });
            }
        }
    },
});
exports.CvListTableHeader = React.createClass({
    getDefaultProps: function () {
        return { searchNavResult: null, listContext: null };
    },
    render: function () {
        var _a = this.props, searchNavResult = _a.searchNavResult, listContext = _a.listContext;
        return (React.createElement("thead", null, searchNavResult ?
            (React.createElement(catreact_1.CvNavigation, { navigationResult: searchNavResult },
                React.createElement(catreact_1.CvForm, { formContext: searchNavResult.navRequest },
                    React.createElement(catreact_1.CvSearchPane, { paneRef: 0, detailsRenderer: function (cvContext, entityRec, callback) {
                            return React.createElement("tr", null, [React.createElement("th", { key: 'select_col' })].concat(listContext.listDef.activeColumnDefs.map(function (colDef, i) {
                                return React.createElement(exports.CvListColumnHeader, { colDef: colDef, searchCallback: callback, key: i });
                            })));
                        } }))))
            :
                (React.createElement("tr", null, [React.createElement("th", { key: "select_col" })].concat(listContext.listDef.activeColumnDefs.map(function (colDef, index) {
                    return React.createElement("th", { key: index }, colDef.heading);
                }))))));
    }
});
exports.CvListColumnHeader = React.createClass({
    getDefaultProps: function () {
        return { colDef: null, searchCallback: null };
    },
    render: function () {
        var _this = this;
        var _a = this.props, colDef = _a.colDef, searchCallback = _a.searchCallback;
        var dir = searchCallback.getSortValueDirection(colDef.name);
        //server may return ASCENDING or ASC and DSC or DESCENDING
        var nextDir = this._isAsc(dir) ? 'DSC' : 'ASC';
        //size the cell
        var sizeClass = ' ' + exports.CvListColumnHeader.classForColumnDef(colDef);
        return React.createElement("th", { className: 'cv-target' + sizeClass, onClick: (function (colName) {
                searchCallback.reopenSearch(function (success, error) {
                    searchCallback.clearSortValues();
                    searchCallback.setSortValue(colName, nextDir, 0);
                    searchCallback.submitSearch(function (success, error) { });
                });
            }).bind(this, colDef.name) },
            React.createElement("span", null, colDef.heading),
            (function () {
                if (dir) {
                    var className = _this._isAsc(dir) ?
                        "glyphicon glyphicon-triangle-top cv-sort-dir" : "glyphicon glyphicon-triangle-bottom cv-sort-dir";
                    return React.createElement("span", { className: className, "aria-hidden": "true" });
                }
                else {
                    return null;
                }
            })());
    },
    _isAsc: function (dir) {
        return dir && dir.indexOf('A') === 0;
    },
    _isDsc: function (dir) {
        return dir && dir.indexOf('D') === 0;
    },
    statics: {
        classForColumnDef: function (colDef) {
            if (colDef.propertyDef.presLength > 500) {
                return 'cv-list-cell-width-xl';
            }
            else if (colDef.propertyDef.presLength >= 200) {
                return 'cv-list-cell-width-lg';
            }
            else if (colDef.propertyDef.presLength >= 100) {
                return 'cv-list-cell-width-md';
            }
            else {
                return 'cv-list-cell-width-default';
            }
        }
    }
});
