"use strict";
/**
 * Created by rburson on 3/14/16.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catavolt_sdk_1 = require("catavolt-sdk");
var catreact_1 = require("catreact");
var CvPopupPrompt_1 = require("./CvPopupPrompt");
/*
 ***************************************************
 * Render a LoginPanel
 ***************************************************
 */
exports.CvLoginPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    getChildContext: function () {
        return this.getDefaultChildContext();
    },
    getDefaultProps: function () {
        return {
            loginListeners: [],
            actionListeners: [],
            defaultClientType: 'RICH_CLIENT',
            defaultDirectUrl: '',
            defaultGatewayUrl: 'www.catavolt.net',
            defaultPassword: '',
            defaultNewPassword: '',
            defaultNewPassword2: '',
            defaultTenantId: '',
            defaultUserId: '',
            showClientType: true,
            showDirectUrl: true,
            showGatewayUrl: true,
            showTenantId: true
        };
    },
    getInitialState: function () {
        return {
            directUrl: this.props.defaultDirectUrl,
            tenantId: this.props.defaultTenantId,
            gatewayUrl: this.props.defaultGatewayUrl,
            userId: this.props.defaultUserId,
            password: this.props.defaultPassword,
            newPassword: this.props.defaultNewPassword,
            newPassword2: this.props.defaultNewPassword2,
            clientType: this.props.defaultClientType,
            error: null,
            passwordExpired: false,
            focusOnPassword: false
        };
    },
    render: function () {
        var _this = this;
        return (React.createElement(catreact_1.CvLogin, { loginListeners: this.props.loginListeners, actionListeners: this.props.actionListeners, renderer: function (cvContext, callback) {
                var answer = null;
                if (!callback.isLoggedIn()) {
                    if (_this.state.passwordExpired) {
                        answer = _this.promptForChangePassword(callback);
                    }
                    else {
                        answer = _this.promptForLogon(callback);
                    }
                }
                return answer;
            } }));
    },
    handleChange: function (field, e) {
        var nextState = {};
        nextState[field] = e.target.value;
        nextState["focusOnPassword"] = false;
        this.setState(nextState);
    },
    handleRadioChange: function (field, value, e) {
        var nextState = {};
        nextState[field] = value;
        this.setState(nextState);
    },
    handleSubmit: function (callback, e) {
        var _this = this;
        e.preventDefault();
        this.setState({ error: null });
        var resultCallback = function (success, error) {
            if (error) {
                var nextState = { error: error };
                if (error instanceof catavolt_sdk_1.DialogException && error.name == "com.dgoi.core.security.PasswordExpiredException") {
                    var cont = function () { _this.setState({ passwordExpired: true, focusOnPassword: true, password: '' }); };
                    var cancel = function () { };
                    CvPopupPrompt_1.openPopupPrompt("Password Expired", "Your password has expired.  Would you like to change your password now?", ["Change Password Now", "Cancel"], [cont, cancel]);
                    ;
                }
                else {
                    _this.setState({ error: error });
                }
            }
        };
        if (this.state.passwordExpired) {
            if (this.state.newPassword != this.state.newPassword2) {
                this.setState({ error: "Your new password is not the same in the two fields." });
            }
            else {
                var host = this.state.directUrl ? this.state.directUrl : this.state.gatewayUrl;
                callback.changePasswordAndLogin(host, this.state.tenantId, this.state.clientType, this.state.userId, this.state.password, this.state.newPassword, resultCallback);
            }
        }
        else if (this.state.directUrl) {
            callback.loginDirectly(this.state.directUrl, this.state.tenantId, this.state.clientType, this.state.userId, this.state.password, resultCallback);
        }
        else {
            callback.login(this.state.gatewayUrl, this.state.tenantId, this.state.clientType, this.state.userId, this.state.password, resultCallback);
        }
    },
    promptForChangePassword: function (callback) {
        var _this = this;
        return React.createElement("div", { className: "well cv-changepassword-form-container animated fadeInUp" },
            React.createElement("form", { className: "form-horizontal cv-changepassword-form", onSubmit: this.handleSubmit.bind(this, callback) },
                (function () {
                    return _this.buildHiddenPromptFields();
                })(),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "userId", className: "col-sm-5 control-label" }, "User Id:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "userId", type: "text", className: "form-control", value: this.state.userId, onChange: this.handleChange.bind(this, 'userId'), required: true }))),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "originalPassword", className: "col-sm-5 control-label" }, "Original password:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "originalPassword", type: "password", className: "form-control", ref: function (input) { return _this.state.focusOnPassword && input && input.focus(); }, value: this.state.password, onChange: this.handleChange.bind(this, 'password'), required: true }))),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "newPassword", className: "col-sm-5 control-label" }, "New password:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "newPassword", type: "password", className: "form-control", value: this.state.newPassword, onChange: this.handleChange.bind(this, 'newPassword'), required: true }))),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "newPassword2", className: "col-sm-5 control-label" }, "Repeat new password:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "newPassword2", type: "password", className: "form-control", value: this.state.newPassword2, onChange: this.handleChange.bind(this, 'newPassword2'), required: true }))),
                (function () {
                    if (_this.props.showClientType) {
                        return (React.createElement("div", { className: "form-group" },
                            React.createElement("label", { htmlFor: "clientType", className: "col-sm-5 control-label" }, "Client Type:"),
                            React.createElement("div", { className: "col-sm-7" },
                                React.createElement("label", { className: "radio-inline" },
                                    React.createElement("input", { id: "clientType", type: "radio", onChange: _this.handleRadioChange.bind(_this, 'clientType', 'LIMITED_ACCESS'), checked: _this.state.clientType === 'LIMITED_ACCESS' }),
                                    "Limited"),
                                React.createElement("label", { className: "radio-inline" },
                                    React.createElement("input", { id: "clientType", type: "radio", onChange: _this.handleRadioChange.bind(_this, 'clientType', 'RICH_CLIENT'), checked: _this.state.clientType === 'RICH_CLIENT' }),
                                    "Rich"))));
                    }
                })(),
                React.createElement("div", { className: "form-group" },
                    React.createElement("table", { className: "cv-changepassword-buttons" },
                        React.createElement("tr", null,
                            React.createElement("td", { className: "col-sm-8 col-sm-offset-2" },
                                React.createElement("button", { type: "submit", className: "btn btn-default btn-primary btn-block", value: "Change" },
                                    "Change Password ",
                                    React.createElement("span", { className: "glyphicon glyphicon-ok" }))),
                            React.createElement("td", { className: "col-sm-4 col-sm-offset-2" },
                                React.createElement("button", { type: "cancel", className: "btn btn-primary btn-block", value: "Cancel", onClick: function () { _this.setState({ passwordExpired: false }); } },
                                    "Cancel ",
                                    React.createElement("span", { className: "glyphicon glyphicon-remove" })))))),
                React.createElement("div", null,
                    React.createElement("div", { className: "cv-login-error" }, this.state.error ?
                        React.createElement("div", null,
                            React.createElement("span", { className: "glyphicon glyphicon-warning-sign" }),
                            React.createElement("span", { style: { marginLeft: '10px' } }, typeof this.state.error === 'string' ? this.state.error : 'Invalid Login')) : null))));
    },
    promptForLogon: function (callback) {
        var _this = this;
        return React.createElement("div", { className: "well cv-login-form-container animated fadeInUp" },
            React.createElement("form", { className: "form-horizontal cv-login-form", onSubmit: this.handleSubmit.bind(this, callback) },
                (function () {
                    return _this.buildHiddenPromptFields();
                })(),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "userId", className: "col-sm-5 control-label" }, "User Id:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "userId", type: "text", className: "form-control", value: this.state.userId, onChange: this.handleChange.bind(this, 'userId'), required: true }))),
                React.createElement("div", { className: "form-group" },
                    React.createElement("label", { htmlFor: "password", className: "col-sm-5 control-label" }, "Password:"),
                    React.createElement("div", { className: "col-sm-7" },
                        React.createElement("input", { id: "password", type: "password", className: "form-control", value: this.state.password, onChange: this.handleChange.bind(this, 'password'), required: true }))),
                (function () {
                    if (_this.props.showClientType) {
                        return (React.createElement("div", { className: "form-group" },
                            React.createElement("label", { htmlFor: "clientType", className: "col-sm-5 control-label" }, "Client Type:"),
                            React.createElement("div", { className: "col-sm-7" },
                                React.createElement("label", { className: "radio-inline" },
                                    React.createElement("input", { id: "clientType", type: "radio", onChange: _this.handleRadioChange.bind(_this, 'clientType', 'LIMITED_ACCESS'), checked: _this.state.clientType === 'LIMITED_ACCESS' }),
                                    "Limited"),
                                React.createElement("label", { className: "radio-inline" },
                                    React.createElement("input", { id: "clientType", type: "radio", onChange: _this.handleRadioChange.bind(_this, 'clientType', 'RICH_CLIENT'), checked: _this.state.clientType === 'RICH_CLIENT' }),
                                    "Rich"))));
                    }
                })(),
                React.createElement("div", { className: "form-group" },
                    React.createElement("div", { className: "col-sm-10 col-sm-offset-2" },
                        React.createElement("button", { type: "submit", className: "btn btn-default btn-primary btn-block", value: "Login" },
                            "Login ",
                            React.createElement("span", { className: "glyphicon glyphicon-log-in" })))),
                React.createElement("div", null,
                    React.createElement("div", { className: "cv-login-error" }, this.state.error ?
                        React.createElement("div", null,
                            React.createElement("span", { className: "glyphicon glyphicon-warning-sign" }),
                            React.createElement("span", { style: { marginLeft: '10px' } }, "Invalid Login")) : null))));
    },
    buildHiddenPromptFields: function () {
        var answer = [];
        if (this.props.showDirectUrl) {
            answer.push(React.createElement("div", { className: "form-group" },
                React.createElement("label", { htmlFor: "directUrl", className: "col-sm-5 control-label" }, "Direct URL:"),
                React.createElement("div", { className: "col-sm-7" },
                    React.createElement("input", { id: "directUrl", type: "text", className: "form-control", value: this.state.directUrl, disabled: !!this.state.gatewayUrl, onChange: this.handleChange.bind(this, 'directUrl') }))));
        }
        if (this.props.showGatewayUrl) {
            answer.push(React.createElement("div", { className: "form-group" },
                React.createElement("label", { htmlFor: "gatewayUrl", className: "col-sm-5 control-label" }, "Gateway URL:"),
                React.createElement("div", { className: "col-sm-7" },
                    React.createElement("div", { className: "input-group" },
                        React.createElement("input", { id: "gatewayUrl", type: "text", className: "form-control", value: this.state.gatewayUrl, onChange: this.handleChange.bind(this, 'gatewayUrl'), disabled: !!this.state.directUrl, "aria-describedby": "http-addon" })))));
        }
        if (this.props.showTenantId) {
            answer.push(React.createElement("div", { className: "form-group" },
                React.createElement("label", { htmlFor: "tenantId", className: "col-sm-5 control-label" }, "Tenant Id:"),
                React.createElement("div", { className: "col-sm-7" },
                    React.createElement("input", { id: "tenantId", type: "text", className: "form-control", value: this.state.tenantId, onChange: this.handleChange.bind(this, 'tenantId'), required: true }))));
        }
        return answer;
    }
});
