"use strict";
/**
 * Created by rburson on 4/27/16.
 */
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_google_maps_1 = require("react-google-maps");
var SearchBoxMod = require("react-google-maps/lib/places/SearchBox");
var SearchBox = SearchBoxMod.default;
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
/*
 ***************************************************
 * Render a Map
 ***************************************************
 */
exports.CvMapPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    componentDidMount: function () {
        var event = { type: catreact_1.CvEventType.MESSAGE,
            eventObj: { message: 'Map Tip: Click on multiple markers to see route and distance. Right-click for a context menu.', type: catreact_1.CvMessageType.INFO } };
        this.eventRegistry().publish(event, false);
        catreact_1.CvActionBase._publishActionStarted('#loadMap', this.props.mapContext, true, this.props.actionListeners, this.eventRegistry());
    },
    getDefaultProps: function () {
        return {
            paneRef: null,
            formContext: null,
            mapContext: null,
            navigationListeners: [],
            selectionListener: null,
            stateChangeListeners: [],
            actionListeners: [],
            navTarget: null,
            containerProps: null,
            actionProvider: null
        };
    },
    getInitialState: function () {
        return { currentSelection: null, previousSelection: null, openMarker: null, openMenu: null, directions: null };
    },
    render: function () {
        var _this = this;
        var queryPaneProps = {
            paneRef: this.props.paneRef,
            formContext: this.props.formContext,
            queryContext: this.props.mapContext,
            stateChangeListeners: this.props.stateChangeListeners,
            actionListeners: this.props.actionListeners,
            actionProvider: this.props.actionProvider
        };
        return React.createElement(catreact_1.CvQueryPane, __assign({}, queryPaneProps, { queryRenderer: function (cvContext, callback) {
                var mapContext = cvContext.scopeCtx.scopeObj;
                var passthroughProps = {
                    paneRef: _this.props.paneRef,
                    formContext: _this.props.formContext,
                    mapContext: mapContext,
                    lastRefreshTime: mapContext.lastRefreshTime,
                    navigationListeners: _this.props.navigationListeners,
                    selectionListener: _this.props.selectionListener,
                    stateChangeListeners: _this.props.stateChangeListeners,
                    actionListeners: _this.props.actionListeners,
                    navTarget: _this.props.navTarget,
                    actionProvider: _this.props.actionProvider
                };
                var mapContainerProps = catavolt_sdk_1.ObjUtil.addAllProps(_this.props.containerProps, { className: 'cv-component-container cv-map-container' });
                return (React.createElement(CvWrappedMap, __assign({ containerElement: React.createElement("div", __assign({}, mapContainerProps)), mapElement: React.createElement("div", { style: { height: "100%" } }) }, passthroughProps)));
            } }));
    }
});
var CvMapPanel_INPUT_STYLE = {
    boxSizing: "border-box",
    MozBoxSizing: "border-box",
    border: "1px solid transparent",
    width: "240px",
    height: "32px",
    marginTop: "27px",
    padding: "0 12px",
    borderRadius: "1px",
    boxShadow: "0 2px 6px rgba(0, 0, 0, 0.3)",
    fontSize: "14px",
    outline: "none",
    textOverflow: "ellipses",
};
var CvMap = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    componentWillMount: function () {
        this.setState({ persistentMarkers: this._generatePersistentMarkers() });
    },
    componentWillReceiveProps: function (nextProps, nextState) {
        if (nextProps.lastRefreshTime && (nextProps.lastRefreshTime.getTime() > this.props.lastRefreshTime.getTime())) {
            this.setState({ persistentMarkers: this._generatePersistentMarkers() });
        }
    },
    getDefaultProps: function () {
        return {
            paneRef: null,
            formContext: null,
            mapContext: null,
            lastRefreshTime: null,
            navigationListeners: [],
            selectionListener: null,
            stateChangeListeners: [],
            actionListeners: [],
            navTarget: null,
            actionProvider: null
        };
    },
    getInitialState: function () {
        return { currentSelection: null, previousSelection: null, openMarker: null, openMenu: null, directions: null, persistentMarkers: [], searchMarkers: [], userMarkers: [] };
    },
    render: function () {
        var _this = this;
        var _a = this.state, currentSelection = _a.currentSelection, previousSelection = _a.previousSelection, directions = _a.directions, openMenu = _a.openMenu, openMarker = _a.openMarker;
        var mapContext = this.props.mapContext;
        var markers = this._getAllMarkers();
        return (React.createElement(react_google_maps_1.GoogleMap, { defaultZoom: 7, defaultCenter: { lat: 39.144973, lng: -100.019531 }, defaultOptions: { fullscreenControl: true, disableDoubleClickZoom: true }, onClick: this._handleMapClick, onDblClick: this._handleMapDoubleClick, ref: function (map) { if (map) {
                _this._initMap(map, markers);
            } } },
            React.createElement(SearchBox, { controlPosition: google.maps.ControlPosition.TOP_LEFT, onPlacesChanged: this._onPlacesChanged, inputPlaceholder: "Search Places", inputStyle: CvMapPanel_INPUT_STYLE, bounds: this._gMap ? this._gMap.getBounds() : null, ref: function (ref) { return _this._searchBox = ref; } }),
            directions ? React.createElement(react_google_maps_1.DirectionsRenderer, { directions: directions, options: { suppressMarkers: true } }) : null,
            markers.map(function (marker, index) {
                var menuDef = (mapContext.menuDefs && mapContext.menuDefs.length > 0) ? mapContext.menuDefs[0].findContextMenuDef() : null;
                var selectionAdapter = new catreact_1.CvValueAdapter();
                selectionAdapter.getDelegateValueListener()([marker.id]);
                /*
                 Note:
                 We have to explicitly pass every prop to the CvDropdownMenu component that might normally be found in the context
                 because the 'GoogleMap' react library interferes with the context
                 */
                return (React.createElement(react_google_maps_1.Marker, { defaultPosition: { lat: marker.lat, lng: marker.lng }, defaultAnimation: google.maps.Animation.DROP, key: marker.id, icon: marker.imgUrl ? { url: marker.imgUrl, scaledSize: new google.maps.Size(30, 30) } : null, title: marker.tipText, draggable: marker.draggable, onMouseOver: _this._handleMarkerOver.bind(_this, marker), onClick: _this._handleMarkerClick.bind(_this, marker), onRightClick: _this._handleMarkerRightClick.bind(_this, marker), onDblClick: _this._handleMarkerDoubleClick.bind(_this, marker), onDragEnd: _this._handleDragEnd.bind(_this, marker) },
                    openMarker && openMarker.id === marker.id ?
                        _this._getInfoDisplay(directions, marker, currentSelection) : null,
                    openMenu && openMenu.id === marker.id ?
                        React.createElement(react_google_maps_1.OverlayView, { position: { lat: marker.lat, lng: marker.lng }, mapPaneName: react_google_maps_1.OverlayView.OVERLAY_MOUSE_TARGET, getPixelPositionOffset: _this._getPixelPositionOffset },
                            React.createElement(catreact_html_1.CvDropdownMenu, { paneContext: mapContext, menuDef: menuDef, navigationListeners: _this.props.navigationListeners, actionListeners: [_this._actionFired.bind(_this, marker)], stateChangeListeners: _this.props.stateChangeListeners, navTarget: _this.props.navTarget, selectionProvider: selectionAdapter, catavolt: _this.catavolt(), initOpen: true, launchMenuElement: React.createElement("span", null), eventRegistry: _this.eventRegistry() }))
                        : null));
            })));
    },
    _actionFired: function (marker, event) {
    },
    _getAllMarkers: function () {
        return this.state.persistentMarkers.concat(this.state.searchMarkers, this.state.userMarkers);
    },
    /*
        Use info window to display directions
     */
    _getInfoDisplay: function (directions, marker, targetMarker) {
        if (!directions) {
            return React.createElement(react_google_maps_1.InfoWindow, { onCloseClick: this._handleInfoClose.bind(this, marker) },
                React.createElement("div", null, marker.desc));
        }
        else {
            if (marker.id == targetMarker.id) {
                var leg = directions.routes[0].legs[0];
                return React.createElement(react_google_maps_1.InfoWindow, { onCloseClick: this._handleInfoClose.bind(this, marker) },
                    React.createElement("div", null,
                        React.createElement("span", { className: "cv-icon cv-map-info pull-right", "aria-hidden": "true" }),
                        React.createElement("div", null,
                            React.createElement("strong", null, 'To: '),
                            marker.desc),
                        React.createElement("div", null, leg.end_address),
                        React.createElement("div", null, leg.distance ? leg.distance.text : null),
                        React.createElement("div", null, leg.duration ? leg.duration.text : null)));
            }
        }
        return null;
    },
    /*
        Create the markers that are included in the ListContext
     */
    _generatePersistentMarkers: function () {
        var mapContext = this.props.mapContext;
        var mapDef = mapContext.mapDef;
        var records = catavolt_sdk_1.ArrayUtil.copy(mapContext.scroller.buffer);
        var markers = records.map(function (record) {
            return {
                id: record.objectId,
                lat: record.propAtName(mapDef.latitudePropName).value,
                lng: record.propAtName(mapDef.longitudePropName).value,
                desc: record.propAtName(mapDef.descriptionPropName).value,
                imgUrl: record.imageName,
                tipText: record.tipText,
                imagePlc: record.imagePlacement
            };
        });
        return markers;
    },
    _getPixelPositionOffset: function (width, height) {
        return { x: -(width / 2), y: -(height / 2) };
    },
    /*
        Update the position and info of the User-placed Marker, when dragged
     */
    _handleDragEnd: function (marker, e) {
        var _this = this;
        var currentUserMarkers = this.state.userMarkers;
        currentUserMarkers.splice(currentUserMarkers.indexOf(marker), 1);
        var nextMarker = catavolt_sdk_1.ObjUtil.addAllProps(marker, {});
        var lat = e.latLng.lat();
        var lng = e.latLng.lng();
        nextMarker.lat = lat;
        nextMarker.lng = lng;
        nextMarker.desc = lat + ', ' + lng;
        currentUserMarkers.push(nextMarker);
        this._reverseGeolocate(lat, lng, (function (address) {
            nextMarker.desc = address;
            _this.setState({ userMarkers: currentUserMarkers });
        }));
    },
    /*
        Clicking on an empty area of the map should reset selected markers, directions, etc.
     */
    _handleMapClick: function (e) {
        if (!this.state.openMenu) {
            this.setState({
                openMarker: null,
                directions: null,
                currentSelection: null,
                previousSelection: null
            });
        }
    },
    /*
        Place a User Marker, where double-clicked
     */
    _handleMapDoubleClick: function (e) {
        var lat = e.latLng.lat();
        var lng = e.latLng.lng();
        var userMarkers = this.state.userMarkers.slice();
        var marker = {
            id: 'user_' + userMarkers.length,
            lat: lat,
            lng: lng,
            desc: 'Dropped Pin',
            tipText: lat + ', ' + lng,
            draggable: true
        };
        this._reverseGeolocate(lat, lng, (function (address) { return marker.desc = address; }));
        userMarkers.push(marker);
        this.setState({ userMarkers: userMarkers });
    },
    /*
        Remove a User Marker when double-clicked
     */
    _handleMarkerDoubleClick: function (marker, e) {
        var currentUserMarkers = this.state.userMarkers;
        currentUserMarkers.splice(currentUserMarkers.indexOf(marker), 1);
        this.setState({
            userMarkers: currentUserMarkers,
            openMarker: null,
            directions: null,
            currentSelection: null,
            previousSelection: null
        });
    },
    /*
        Show marker info when moused over
     */
    _handleMarkerOver: function (marker, e) {
        if (!this.state.directions) {
            this.setState({
                openMarker: marker,
                openMenu: null
            });
        }
    },
    /*
        When marker is clicked, make it the current selection and check for a previously clicked marker
        from which to route directions
     */
    _handleMarkerClick: function (marker, e) {
        var _this = this;
        if (this.props.selectionListener)
            this.props.selectionListener([marker.id]);
        var previousSelection = this.state.currentSelection;
        var currentSelection = marker;
        if (previousSelection && currentSelection.id !== previousSelection.id) {
            var ds = new google.maps.DirectionsService();
            ds.route({
                origin: new google.maps.LatLng(previousSelection.lat, previousSelection.lng),
                destination: new google.maps.LatLng(currentSelection.lat, currentSelection.lng),
                travelMode: google.maps.TravelMode.DRIVING,
                provideRouteAlternatives: true
            }, function (result, status) {
                if (status === google.maps.DirectionsStatus.OK) {
                    _this.setState({
                        directions: result,
                        currentSelection: currentSelection,
                        previousSelection: previousSelection,
                        openMarker: marker,
                        openMenu: null
                    });
                }
                else {
                    var event_1 = { type: catreact_1.CvEventType.MESSAGE,
                        eventObj: { message: "error fetching directions " + result,
                            messageObj: new catavolt_sdk_1.DialogException('', 'Error retrieving directions'), type: catreact_1.CvMessageType.ERROR } };
                    _this.eventRegistry().publish(event_1, false);
                }
            });
        }
        else {
            this.setState({
                currentSelection: currentSelection,
                previousSelection: previousSelection,
                openMenu: null,
                directions: null
            });
        }
    },
    /*
        Show context menu when a Persistent Marker is right-clicked
     */
    _handleMarkerRightClick: function (marker, e) {
        if (this.props.selectionListener)
            this.props.selectionListener([marker.id]);
        this.setState({
            previousSelection: this.state.currentSelection,
            currentSelection: marker,
            openMenu: marker
        });
    },
    /*
        Close the info window
     */
    _handleInfoClose: function (marker, e) {
        this.setState({ openMarker: null });
    },
    /*
        Initialize the map and set bounds
     */
    _initMap: function (map, latLng) {
        if (!this._gMap && latLng && latLng.length > 0) {
            this._gMap = map;
            this._setBounds(map, latLng);
            catreact_1.CvActionBase._publishActionFinished('#loadMap', this.props.mapContext, this.props.actionListeners, this.eventRegistry());
        }
    },
    _setBounds: function (map, latLng) {
        var latLngBounds = new google.maps.LatLngBounds();
        for (var i = 0; i < latLng.length; i++) {
            latLngBounds.extend(new google.maps.LatLng(latLng[i].lat, latLng[i].lng));
        }
        map.fitBounds(latLngBounds);
    },
    _geoLocate: function (callback) {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function (position) {
                var pos = {
                    lat: position.coords.latitude,
                    lng: position.coords.longitude
                };
                callback(pos);
            }, function () {
                var event = { type: catreact_1.CvEventType.MESSAGE,
                    eventObj: { message: 'Geolocation failed',
                        messageObj: new catavolt_sdk_1.DialogException('', 'Geolocation failed'), type: catreact_1.CvMessageType.ERROR } };
                this.eventRegistry().publish(event, false);
            });
        }
        else {
            var event_2 = { type: catreact_1.CvEventType.MESSAGE,
                eventObj: { message: 'Geolocation not supported (or disabled)',
                    messageObj: new catavolt_sdk_1.DialogException('', 'Geolocation not supported (or disabled)'), type: catreact_1.CvMessageType.ERROR } };
            this.eventRegistry().publish(event_2, false);
        }
    },
    /*
        Handle search results
     */
    _onPlacesChanged: function () {
        var markers = [];
        this._searchBox.getPlaces().forEach(function (place) {
            markers.push({
                id: place.place_id,
                lat: place.geometry.location.lat(),
                lng: place.geometry.location.lng(),
                desc: place.formatted_address,
                imgUrl: place.icon,
                tipText: place.name,
            });
        });
        this._setBounds(this._gMap, markers.concat(this.state.userMarkers, this.state.persistentMarkers));
        this.setState({ searchMarkers: markers });
    },
    _reverseGeolocate: function (lat, lng, callback) {
        var _this = this;
        var geocoder = new google.maps.Geocoder;
        geocoder.geocode({ 'location': { lat: lat, lng: lng } }, function (results, status) {
            if (status == google.maps.GeocoderStatus.OK) {
                if (results[0]) {
                    callback(results[0].formatted_address);
                }
            }
            else {
                var event_3 = { type: catreact_1.CvEventType.MESSAGE,
                    eventObj: { message: 'Reverse Geolocation failed',
                        messageObj: new catavolt_sdk_1.DialogException('', 'Reverse Geolocation failed'), type: catreact_1.CvMessageType.ERROR } };
                _this.eventRegistry().publish(event_3, false);
            }
        });
    }
});
var CvWrappedMap = react_google_maps_1.withGoogleMap(function (props) { return (React.createElement(CvMap, __assign({}, props))); });
