"use strict";
/**
 * Created by rburson on 5/30/16.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catreact_1 = require("catreact");
var catavolt_sdk_1 = require("catavolt-sdk");
/*
 ***************************************************
 * Render a Message
 ***************************************************
 */
exports.CvMessagePanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    render: function () {
        var _this = this;
        return React.createElement(catreact_1.CvMessagePane, { messageRenderer: function (cvContext, message, callback) {
                toastr.options.onHidden = function () {
                    callback.clear();
                };
                if (message.type === catreact_1.CvMessageType.ERROR) {
                    if (message.messageObj && message.messageObj instanceof catavolt_sdk_1.DialogException) {
                        var dialogException = message.messageObj;
                        var text = _this._createUserMessage(dialogException);
                        toastr.error(text, dialogException.title, { timeOut: 10000, extendedTimeOut: 3000, closeButton: true,
                            showMethod: 'slideDown', hideMethod: 'slideUp',
                            progressBar: true, preventDuplicates: true });
                    }
                    else {
                        toastr.error(message.message + ' : ' + catavolt_sdk_1.Log.formatRecString(message.messageObj), 'ERROR', { timeOut: 10000, extendedTimeOut: 3000, closeButton: true,
                            showMethod: 'slideDown', hideMethod: 'slideUp',
                            progressBar: true, preventDuplicates: true });
                    }
                    catavolt_sdk_1.Log.error(message.message);
                    catavolt_sdk_1.Log.error(message.messageObj);
                }
                else {
                    toastr.info(message.message, '', { timeOut: 10000, extendedTimeOut: 3000, closeButton: true,
                        showMethod: 'slideDown', hideMethod: 'slideUp',
                        progressBar: true, preventDuplicates: true });
                }
                return null;
            } });
    },
    _createUserMessage: function (dialogException) {
        var text = dialogException.message || dialogException.name || 'An Error Occurred';
        if (dialogException.userMessages && dialogException.userMessages.length > 0) {
            dialogException.userMessages.forEach(function (userMessage) {
                text += '<br><strong>' + userMessage.message + '</strong>';
            });
        }
        return text;
    }
});
