"use strict";
/**
 * Created by rburson on 3/18/16.
 */
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
/**
 * Render a NavRequest
 */
exports.CvNavigator = React.createClass({
    propTypes: {
        /**
         * navigationResult?:CvNavigationResult;
         */
        navigationResult: React.PropTypes.object,
        /**
         * alternative to navigationResult - the id will be used to find the navigationResult in the cache
         */
        navigationId: React.PropTypes.string,
        /**
         * navigationListeners?:Array<(event:CvEvent<CvNavigationResult>)=>void>;
         */
        navigationListeners: React.PropTypes.arrayOf(React.PropTypes.func),
        /**
         * actionListeners?:Array<(event:CvEvent<CvActionFiredResult>)=>void>;
         */
        actionListeners: React.PropTypes.arrayOf(React.PropTypes.func),
        /**
         * stateChangeListeners?:Array<(event:CvEvent<CvStateChangeResult>)=>void>;
         */
        stateChangeListeners: React.PropTypes.arrayOf(React.PropTypes.func),
        layoutOverrideElement: React.PropTypes.element,
        /**
         * formComponentProvider?:CvFormComponentProvider;
         */
        formComponentProvider: React.PropTypes.object,
        targetId: React.PropTypes.string,
        catavolt: React.PropTypes.instanceOf(catavolt_sdk_1.AppContext),
        eventRegistry: React.PropTypes.instanceOf(catreact_1.CvEventRegistry),
        /**
         * renderer signature: (cvContext:CvContext, callbackObj?:any)=>{}
         * ctx.cvContext.scopeCtx.scopeObj will be of type NavRequest
         */
        renderer: React.PropTypes.func,
        displayProperties: React.PropTypes.any,
        displayPropChangeListeners: React.PropTypes.arrayOf(React.PropTypes.func)
    },
    mixins: [catreact_1.CvBaseMixin],
    shouldComponentUpdate: function (nextProps, nextState) {
        return ((nextProps.navigationId && nextProps.navigationId !== this.props.navigationId) ||
            (nextProps.navigationResult && nextProps.navigationResult !== this.props.navigationResult) ||
            (nextProps.displayProperties && nextProps.displayProperties !== this.props.displayProperties));
    },
    getDefaultProps: function () {
        return {
            navigationResult: null,
            navigationId: null,
            navigationListeners: [],
            actionListeners: [],
            stateChangeListeners: [],
            layoutOverrideElem: null,
            formComponentProvider: null,
            persistent: false,
            targetId: null,
            displayProperties: new catreact_html_1.CvDisplayProperties(),
            displayPropChangeListeners: []
        };
    },
    navRequest: function () {
        if (this.props.navigationResult && this.props.navigationResult.navRequest) {
            return this.props.navigationResult.navRequest;
        }
        else if (this.props.navigationId) {
            return this.eventRegistry().getEventByKey(this.props.navigationId).eventObj.navRequest;
        }
        else {
            return null;
        }
    },
    render: function () {
        /* @TODO
            Add web navigation renderer back by adding an optional webRenderer to CvFormPane
            See prior version of this file...
         */
        var _this = this;
        return React.createElement(catreact_1.CvNavigation, { navigationResult: this.props.navigationResult, navigationId: this.props.navigationId, persistent: this.props.persistent, targetId: this.props.targetId, renderer: function (cvContext) {
                return React.createElement(catreact_html_1.CvFormPanel, { formContext: cvContext.scopeCtx.scopeObj, navigationListeners: _this.props.navigationListeners, stateChangeListeners: _this.props.stateChangeListeners, actionListeners: _this.props.actionListeners, layoutOverrideElem: _this.props.layoutOverrideElem, formComponentProvider: _this.props.formComponentProvider, displayProperties: _this.props.displayProperties, displayPropChangeListeners: _this.props.displayPropChangeListeners });
            } });
    }
});
