"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Prompt with some text and some actions buttons.
 */
var React = require("react");
var catreact_1 = require("catreact");
var EMPTY_STATE = {
    popupActive: false,
    title: "",
    message: "",
    buttonTexts: [],
    actions: []
};
/**
 * Value to be assigned when CvPromptPopup is mounted.
 */
var openPopupPromptListener;
function promptOpenUrl(url) {
    var cont = function () { window.open(url, '_blank'); };
    var cancel = function () { };
    openPopupPrompt("URL", "Press continue to process this URL: " + url, ["Continue", "Cancel"], [cont, cancel]);
}
exports.promptOpenUrl = promptOpenUrl;
function openPopupPrompt(title, message, buttonTexts, actions, containerClass, buttonClass) {
    if (openPopupPromptListener != null) {
        openPopupPromptListener({ title: title, message: message, buttonTexts: buttonTexts, actions: actions });
    }
}
exports.openPopupPrompt = openPopupPrompt;
/**
 Component that overlays a signature popup.
 */
exports.CvPopupPrompt = React.createClass({
    componentWillMount: function () {
        var promptProvider = new catreact_1.CvValueAdapter();
        promptProvider.subscribe(this._handleOpenPrompt);
        openPopupPromptListener = promptProvider.createValueListener();
    },
    getInitialState: function () {
        return EMPTY_STATE;
    },
    render: function () {
        var _this = this;
        return (React.createElement("div", { className: "modal fade cv-popup-prompt-wrapper", role: "dialog", key: "CvPopupPrompt", ref: function (d) {
                var visible = (_this.state != null) && (_this.state.popupActive);
                if (visible) {
                    var m = $(d);
                    if (m && m.modal) {
                        m.modal({ show: true, keyboard: false, backdrop: 'static' });
                    }
                }
                else {
                    var m = $(d);
                    if (m && m.modal) {
                        m.modal('hide');
                    }
                }
            } },
            React.createElement("div", { className: "modal-dialog cv-popup-prompt-container" },
                React.createElement("div", { className: "modal-content " },
                    React.createElement("div", { className: "modal-header cv-popup-prompt-header" },
                        React.createElement("h2", null, this.state.title)),
                    React.createElement("div", { className: "modal-body cv-popup-prompt-body" },
                        React.createElement("p", null, this.state.message)),
                    React.createElement("div", { className: "modal-footer cv-popup-prompt-button-container" }, (function () {
                        var elems = [];
                        _this.state.buttonTexts.map(function (text, index) {
                            elems.push(React.createElement("button", { type: "button", className: "btn btn-default cv-popup-prompt-button", key: index, onClick: function () {
                                    _this.state.actions[index]();
                                    _this.setState(EMPTY_STATE);
                                } }, text));
                        });
                        return elems;
                    })())))));
    },
    _handleOpenPrompt: function (promptBundle) {
        promptBundle["popupActive"] = true;
        this.setState(promptBundle);
    },
});
