"use strict";
/**
 * Created by rburson on 3/18/16.
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
var catavolt_sdk_2 = require("catavolt-sdk");
var CvSignaturePopup_1 = require("./CvSignaturePopup");
var CvImage_1 = require("./CvImage");
;
var PrintBundle = (function () {
    function PrintBundle(printMarkupDef, printMarkupContext, detailsCallback, listeners) {
        this.printMarkupDef = printMarkupDef;
        this.printMarkupContext = printMarkupContext;
        this.detailsCallback = detailsCallback;
        this.listeners = listeners;
        this.radioGroupRegistry = new RadioGroupRegistry();
    }
    return PrintBundle;
}());
var RadioGroupRegistryEntry = (function () {
    function RadioGroupRegistryEntry(value, cb) {
        this.value = value;
        this.cb = cb;
    }
    ;
    return RadioGroupRegistryEntry;
}());
var RadioGroupRegistry = (function () {
    function RadioGroupRegistry() {
        this._controls = {};
    }
    RadioGroupRegistry.prototype.addControl = function (radioGroup, value, cb) {
        var existing = this._controls[radioGroup];
        if (!existing) {
            existing = new Array();
        }
        // If there is already an entry for <value> then drop it out.
        existing = existing.filter(function (rge) { return (rge.value != value); });
        // Add control to registry.
        existing.push(new RadioGroupRegistryEntry(value, cb));
        this._controls[radioGroup] = existing;
    };
    RadioGroupRegistry.prototype.forceUpdate = function (radioGroup) {
        var existing = this._controls[radioGroup];
        if (existing) {
            existing.forEach(function (rge) { return (rge.cb()); });
        }
    };
    return RadioGroupRegistry;
}());
function hasInitialFocus(context, propName) {
    return context.printMarkupDef.focusPropName ?
        propName == context.printMarkupDef.focusPropName : false;
}
var PForm = (function (_super) {
    __extends(PForm, _super);
    function PForm() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PForm.prototype.childrenFromModel = function () {
        var bundle = this.props.printBundle;
        var form = bundle.printMarkupDef.printMarkupModel;
        var answer = new Array();
        var pagePP = { height: form.layout.singleHeightNum(), width: form.layout.singleWidthNum(), left: 0, top: 0 };
        var separatorPP = { height: PForm.pageSeparatorHeight, width: 1, left: 0, top: 0 };
        for (var i = 0; i < form.pageChildren.length; i++) {
            var p = form.pageChildren[i];
            answer.push(React.createElement(PPage, { key: p.id, printBundle: bundle, page: p, positionProps: pagePP, backgroundColor: form.backgroundColor }));
            if (i < form.pageChildren.length - 1) {
                answer.push(React.createElement(PPageSeparator, { key: "GenSep_" + i, printBundle: bundle, positionProps: separatorPP }));
            }
        }
        return answer;
    };
    PForm.prototype.render = function () {
        var form = this.props.printBundle.printMarkupDef.printMarkupModel;
        var formHeight = form.layout.singleHeightNum() * form.pageChildren.length + (form.pageChildren.length - 1) * PForm.pageSeparatorHeight;
        var style = { position: "relative", height: formHeight, width: form.layout.singleWidthNum(), marginLeft: 5, marginBottom: 5 };
        var styleCentered = { height: formHeight, width: form.layout.singleWidthNum() };
        return React.createElement("div", { style: style }, this.childrenFromModel());
    };
    return PForm;
}(React.Component));
PForm.pageSeparatorHeight = 35;
var PPage = (function (_super) {
    __extends(PPage, _super);
    function PPage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PPage.prototype.render = function () {
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, { backgroundColor: catreact_1.ColorUtil.toColor(this.props.backgroundColor) });
        return React.createElement("div", { style: style }, CvPrintUtil.gridsAsChildren(this.props.printBundle, this.props.page.gridChildren, this.props.positionProps.width));
    };
    return PPage;
}(React.Component));
///////////////////////////////////////////////////////////////////////////////
// Page Separator
///////////////////////////////////////////////////////////////////////////////
var PPageSeparator = (function (_super) {
    __extends(PPageSeparator, _super);
    function PPageSeparator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PPageSeparator.prototype.render = function () {
        var style = { height: this.props.positionProps.height, width: this.props.positionProps.width };
        return React.createElement("div", { style: style });
    };
    return PPageSeparator;
}(React.Component));
var PGrid = (function (_super) {
    __extends(PGrid, _super);
    function PGrid() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PGrid.prototype.childrenFromModel = function (props) {
        // The top is a little tricky.  Keep a running total of all child heights added.  Subtracting this gets
        // our cell to the top.  Then add in a running total based on the row we are working on.
        var allAddedHeights = 0;
        var currentRowOffset = 0;
        var prevTop = 0;
        var answer = [];
        var row = 0;
        var grid = this.props.grid;
        grid.layout.heights.map(function (hrn) {
            var nextLeft = 0;
            var height = hrn.resolveWithFill(props.parentSize);
            var col = 0;
            grid.layout.widths.map(function (wrn) {
                var c = grid.cellChildren[row][col];
                var width = wrn.resolveWithFill(props.parentSize);
                var myTop = currentRowOffset - allAddedHeights;
                var pp = { height: height, width: width, left: nextLeft, top: myTop };
                answer.push(React.createElement(PCell, { key: c.id, printBundle: props.printBundle, cell: c, positionProps: pp }));
                nextLeft += width;
                col++;
            });
            currentRowOffset += height;
            row++;
        });
        return answer;
    };
    PGrid.prototype.render = function () {
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        return React.createElement("div", { style: style }, this.childrenFromModel(this.props));
    };
    return PGrid;
}(React.Component));
var PCell = (function (_super) {
    __extends(PCell, _super);
    function PCell() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PCell.prototype.render = function () {
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        if (this.props.cell.backgroundColor) {
            style["backgroundColor"] = catreact_1.ColorUtil.toColor(this.props.cell.backgroundColor);
        }
        return React.createElement("div", { style: style },
            CvPrintUtil.gridsAsChildren(this.props.printBundle, this.props.cell.gridChildren, this.props.cell.cellWidth),
            CvPrintUtil.componentsAsChildren(this.props.printBundle, this.props.cell.componentChildren, this.props.cell.cellWidth, this.props.cell.cellHeight));
    };
    return PCell;
}(React.Component));
var PGridLines = (function (_super) {
    __extends(PGridLines, _super);
    function PGridLines() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.OVERFLOW = 5;
        return _this;
    }
    PGridLines.prototype.componentDidMount = function () {
        this.updateCanvas();
    };
    PGridLines.prototype.updateCanvas = function () {
        var canvas = this.refs["mycanvas"];
        // var canvas:HTMLCanvasElement = document.getElementById("mycanvas") as HTMLCanvasElement;
        var ctx = canvas.getContext("2d");
        ctx.globalCompositeOperation = 'source-over';
        ctx.strokeStyle = "black";
        for (var _i = 0, _a = this.props.grid.gridLines; _i < _a.length; _i++) {
            var gl = _a[_i];
            ctx.beginPath();
            ctx.lineWidth = gl.lineWidth;
            ctx.lineCap = "square";
            ctx.moveTo(gl.start.x + this.OVERFLOW, gl.start.y + this.OVERFLOW);
            ctx.lineTo(gl.end.x + this.OVERFLOW, gl.end.y + this.OVERFLOW);
            ctx.stroke();
        }
    };
    PGridLines.prototype.render = function () {
        // Adjust the positionProps to account for the overflow.  The overlfow allows the lines to exceed the bounds.
        var newPP = { height: this.props.positionProps.height + this.OVERFLOW * 2, width: this.props.positionProps.width + this.OVERFLOW * 2,
            left: this.props.positionProps.left - this.OVERFLOW, top: this.props.positionProps.top - this.OVERFLOW };
        var style = CvPrintUtil.applySizeAndLocationStyle(newPP, { pointerEvents: "none" });
        return React.createElement("div", { style: style },
            React.createElement("canvas", { ref: "mycanvas", height: newPP.height, width: newPP.width }));
    };
    return PGridLines;
}(React.Component));
var PButton = (function (_super) {
    __extends(PButton, _super);
    function PButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PButton.prototype.render = function () {
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, { cursor: "pointer" });
        if (!this.props.button.urlString)
            return null;
        var path = this.props.button.binding.path;
        var leader = "catavolt:action:name:";
        var actionID = "";
        if (path && path.length > leader.length) {
            actionID = path.substr(leader.length);
        }
        return React.createElement(catreact_1.CvAction, { actionId: actionID, paneContext: this.props.printBundle.printMarkupContext, navigationListeners: this.props.printBundle.listeners.navigationListeners, actionListeners: this.props.printBundle.listeners.actionListeners, stateChangeListeners: this.props.printBundle.listeners.stateChangeListeners },
            React.createElement(catreact_html_1.CvImage, { style: style, src: this.props.button.urlString }));
    };
    return PButton;
}(React.Component));
var PCheckbox = (function (_super) {
    __extends(PCheckbox, _super);
    function PCheckbox(props) {
        var _this = _super.call(this, props) || this;
        _this.state = { radioGroupChanged: 0 };
        return _this;
    }
    PCheckbox.prototype.componentDidUpdate = function () {
        this.updateCanvas(this.canvasFromRef);
    };
    PCheckbox.prototype.updateCanvas = function (canvasParm) {
        this.canvasFromRef = canvasParm;
        if (this.canvasFromRef) {
            // var canvas:HTMLCanvasElement = document.getElementById("mycanvas") as HTMLCanvasElement;
            var ctx = this.canvasFromRef.getContext("2d");
            ctx.globalCompositeOperation = 'source-over';
            ctx.strokeStyle = "black";
            var h = this.canvasFromRef.height;
            var w = this.canvasFromRef.width;
            ctx.clearRect(0, 0, w, h);
            // Fill with appropriate color
            if (this._isSeleced()) {
                ctx.fillStyle = catreact_1.ColorUtil.toColor(this.props.checkbox.checkedColor);
            }
            else {
                ctx.fillStyle = catreact_1.ColorUtil.toColor(this.props.checkbox.uncheckedColor);
            }
            ctx.fillRect(0, 0, w, h);
            // Draw the framing outline if there is a lineWidth
            if (this.props.checkbox.lineWidth > 0) {
                ctx.beginPath();
                ctx.lineWidth = this.props.checkbox.lineWidth;
                ctx.lineCap = "square";
                ctx.moveTo(0, 0);
                ctx.lineTo(0, h);
                ctx.lineTo(w, h);
                ctx.lineTo(w, 0);
                ctx.lineTo(0, 0);
                if (this._isSeleced()) {
                    ctx.moveTo(0, 0);
                    ctx.lineTo(w, h);
                    ctx.moveTo(0, h);
                    ctx.lineTo(w, 0);
                }
                ctx.stroke();
            }
        }
    };
    PCheckbox.prototype._isSeleced = function () {
        var b = this._binding();
        if (b.propertyName) {
            var prop = this.props.printBundle.printMarkupContext.buffer.propAtName(b.propertyName);
            var propDef = this.props.printBundle.printMarkupContext.entityRecDef.propDefAtName(b.propertyName);
        }
        if (!prop)
            return false; // To be called again when there is data
        var pv = (prop.value instanceof catavolt_sdk_1.CodeRef) ? prop.value.code : prop.value;
        var tv = this._trueValue();
        return (tv == pv);
    };
    PCheckbox.prototype._trueValue = function () {
        return this._binding().hasConstant ? this._binding().constantValue : true;
    };
    PCheckbox.prototype.render = function () {
        var _this = this;
        var b = this._binding();
        if (b.hasConstant) {
            this.props.printBundle.radioGroupRegistry.addControl(this.props.checkbox.radioGroup, this._trueValue(), function () { _this._forceRefresh(); });
        }
        if (b.propertyName) {
            var prop = this.props.printBundle.printMarkupContext.buffer.propAtName(b.propertyName);
            var propDef = this.props.printBundle.printMarkupContext.entityRecDef.propDefAtName(b.propertyName);
        }
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        style = CvPrintUtil.applyPaddingStyleToSizeAndLoc(this.props.checkbox.padding, style);
        if (!this._isReadOnly(prop)) {
            style["cursor"] = "pointer";
        }
        return React.createElement("div", { style: style, onClick: this._checkboxClick.bind(this, prop, propDef) },
            React.createElement("canvas", { ref: function (c) { _this.updateCanvas(c); }, height: style.height, width: style.width }));
    };
    PCheckbox.prototype._forceRefresh = function () {
        var current = this.state && !isNaN(this.state.radioGroupChanged) ? this.state.radioGroupChanged : 0;
        this.setState({ radioGroupChanged: ++current });
    };
    PCheckbox.prototype._binding = function () {
        return this.props.checkbox.binding;
    };
    PCheckbox.prototype._checkboxClick = function (prop, propDef, e) {
        if (!this._isReadOnly(prop)) {
            var cb = this.props.printBundle.detailsCallback;
            if (!this._isSeleced()) {
                // if(this.props.valueChangeListener) this.props.valueChangeListener(propName, propDef, true);
                cb.setPropValue(prop.name, this._trueValue());
            }
            else {
                // if(this.props.valueChangeListener) this.props.valueChangeListener(propName, propDef, false);
                if (!this._binding().hasConstant) {
                    cb.setPropValue(prop.name, false);
                }
            }
            if (this._binding().hasConstant) {
                this.props.printBundle.radioGroupRegistry.forceUpdate(this.props.checkbox.radioGroup);
            }
            else {
                this.setState({ radioGroupChanged: this.state.radioGroupChanged + 1 });
                // this.updateCanvas();
            }
        }
    };
    PCheckbox.prototype._isReadOnly = function (prop) {
        return prop ? this.props.printBundle.printMarkupContext.isReadModeFor(prop.name) : true;
    };
    return PCheckbox;
}(React.Component));
;
var PDatePicker = (function (_super) {
    __extends(PDatePicker, _super);
    function PDatePicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PDatePicker.prototype.render = function () {
        var _this = this;
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        style = CvPrintUtil.applyTextAttributes(this.props.positionProps.height, this.props.datePicker.textAttributes, style);
        style = CvPrintUtil.applyPaddingStyle(this.props.datePicker.padding, style);
        var b = this.props.datePicker.binding;
        var prop = this.props.printBundle.printMarkupContext.buffer.propAtName(b.propertyName);
        var propDef = this.props.printBundle.printMarkupContext.entityRecDef.propDefAtName(b.propertyName);
        if (!prop)
            return null;
        var isReadOnly = this.props.printBundle.printMarkupContext.isReadModeFor(prop.name);
        var val = null;
        if (prop.value) {
            // Build the ISO string because toISOString() will adjust for timezone, which we don't want.
            val = catreact_1.DateUtil.toISOFormatNoOffset(prop.value);
        }
        var focusFn = function (ref) { if (ref && hasInitialFocus(_this.props.printBundle.printMarkupContext, prop.name))
            ref.focus(); };
        return React.createElement("input", { id: this.props.datePicker.id, type: "date", className: "cv-print-control", style: style, readOnly: isReadOnly, onBlur: this._datePickerChange.bind(this, prop, propDef), defaultValue: val, ref: focusFn });
    };
    PDatePicker.prototype._datePickerChange = function (prop, propDef, e) {
        if (prop) {
            var cb = this.props.printBundle.detailsCallback;
            cb.setPropValue(prop.name, e.currentTarget.value);
        }
    };
    return PDatePicker;
}(React.Component));
var PImage = (function (_super) {
    __extends(PImage, _super);
    function PImage() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PImage.prototype.render = function () {
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        if (!this.props.image.urlString)
            return null;
        return React.createElement(catreact_html_1.CvImage, { style: style, src: this.props.image.urlString });
    };
    return PImage;
}(React.Component));
var PLabel = (function (_super) {
    __extends(PLabel, _super);
    function PLabel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PLabel.prototype.render = function () {
        var style = { wordWrap: "break-word", wordBreak: "keep-all", textOverflow: "clip", overflow: "hidden" };
        style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, style);
        style["pointerEvents"] = "none"; // Labels may be on top of checkboxes
        style = CvPrintUtil.applyTextAttributes(this.props.positionProps.height, this.props.label.textAttributes, style);
        style = CvPrintUtil.applyPaddingStyle(this.props.label.padding, style);
        return React.createElement("p", { key: this.props.label.id, style: style }, this.props.label.text);
    };
    return PLabel;
}(React.Component));
var PSignatureCapture = (function (_super) {
    __extends(PSignatureCapture, _super);
    function PSignatureCapture() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PSignatureCapture.prototype.render = function () {
        var _this = this;
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps);
        var b = this.props.signature.binding;
        var readOnly = this.props.printBundle.printMarkupContext.isReadModeFor(b.propertyName);
        var detailsContext = this.props.printBundle.printMarkupContext;
        var detailsCallback = this.props.printBundle.detailsCallback;
        var emptyClassSelector = function (propDef, defaultClass) { return "cv-print-control"; };
        var hasFocus = hasInitialFocus(this.props.printBundle.printMarkupContext, b.propertyName);
        var imageProducers = null;
        if (!readOnly) {
            imageProducers = [
                {
                    prodImageCB: function (listener) {
                        CvSignaturePopup_1.openSignaturePopup(listener, _this.props.signature, { width: style.width, height: style.height });
                    },
                    buttonClassName: CvImage_1.CvImageDefaultSignatureButtonClass, includeWhenImageisPresent: true, includeWhenImageIsMissing: true,
                    includeWhenImageIsDeleted: true
                }
            ];
        }
        return React.createElement(catreact_html_1.CvAttributeCellValueDef, { detailsContext: detailsContext, detailsCallback: detailsCallback, classSelector: emptyClassSelector, cellValueDef: this.props.attributeCellValueDef, key: this.props.signature.id, imageProducers: imageProducers, inlineStyle: style, imageReadOnly: readOnly, hasFocus: hasFocus });
    };
    return PSignatureCapture;
}(React.Component));
var PTimePicker = (function (_super) {
    __extends(PTimePicker, _super);
    function PTimePicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PTimePicker.prototype.render = function () {
        var _this = this;
        var style = CvPrintUtil.applySizeAndLocationStyle(this.props.positionProps, {});
        style = CvPrintUtil.applyTextAttributes(this.props.positionProps.height, this.props.timePicker.textAttributes, style);
        style = CvPrintUtil.applyPaddingStyle(this.props.timePicker.padding, style);
        var b = this.props.timePicker.binding;
        var prop = this.props.printBundle.printMarkupContext.buffer.propAtName(b.propertyName);
        var propDef = this.props.printBundle.printMarkupContext.entityRecDef.propDefAtName(b.propertyName);
        if (!prop)
            return null;
        var isReadOnly = this.props.printBundle.printMarkupContext.isReadModeFor(prop.name);
        var val = null;
        if (prop.value) {
            val = prop.value.toDateValue().toTimeString().substr(0, 8);
        }
        var focusFn = function (ref) { if (ref && hasInitialFocus(_this.props.printBundle.printMarkupContext, prop.name))
            ref.focus(); };
        return React.createElement("input", { id: this.props.timePicker.id, type: "time", className: "cv-print-control", style: style, readOnly: isReadOnly, onBlur: this._datePickerChange.bind(this, prop, propDef), defaultValue: val, ref: focusFn });
    };
    PTimePicker.prototype._datePickerChange = function (prop, propDef, e) {
        if (prop) {
            var cb = this.props.printBundle.detailsCallback;
            cb.setPropValue(prop.name, e.currentTarget.value);
        }
    };
    return PTimePicker;
}(React.Component));
///////////////////////////////////////////////////////////////////////////////
// Misc
///////////////////////////////////////////////////////////////////////////////
var CvPrintUtil = (function () {
    function CvPrintUtil() {
    }
    CvPrintUtil.applyColorStyle = function (c, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (c) {
            answer["color"] = catreact_1.ColorUtil.toColor(c);
        }
        return answer;
    };
    CvPrintUtil.applyFontSizeStyle = function (size, lineCount, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (!isNaN(size)) {
            // if (lineCount > 1) {
            answer["fontSize"] = size / lineCount * .70 + "px";
            // } else {
            //     answer["fontSize"] = size + "px";
            // }
        }
        return answer;
    };
    CvPrintUtil.applyFontStyle = function (fs, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (fs.underline) {
            answer["textDecoration"] = "underline";
        }
        if (fs.bold) {
            answer["fontWeight"] = "bold";
        }
        if (fs.italic) {
            answer["fontStyle"] = "italic";
        }
        return answer;
    };
    CvPrintUtil.applyPaddingStyle = function (p, target) {
        // Not sure this is ever right.  Should we always use applyPaddingStyleToSizeAndLoc
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (p) {
            answer["paddingTop"] = p.top;
            answer["paddingRight"] = p.right;
            answer["paddingBottom"] = p.bottom;
            answer["paddingLeft"] = p.left;
        }
        return answer;
    };
    CvPrintUtil.applyPaddingStyleToSizeAndLoc = function (p, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (p) {
            var h = answer["height"];
            var w = answer["width"];
            var left = answer["left"];
            var top_1 = answer["top"];
            answer["height"] = Math.max(0, h - p.top - p.bottom);
            answer["width"] = Math.max(0, w - p.left - p.right);
            answer["top"] = top_1 + p.top;
            answer["left"] = left + p.left;
        }
        return answer;
    };
    CvPrintUtil.applySizeAndLocationStyle = function (pp, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        return catavolt_sdk_1.ObjUtil.addAllProps(answer, { height: pp.height, width: pp.width, position: "absolute", left: pp.left, top: pp.top });
    };
    CvPrintUtil.applyTextAlignment = function (t, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        if (t.textAlignment) {
            if (t.textAlignment.isRight) {
                answer["textAlign"] = "right";
                // answer["justifyContent"] = "flex-end"
            }
            else if (t.textAlignment.isCenter) {
                answer["textAlign"] = "center";
                // answer["justifyContent"] = "center"
            }
            else {
                answer["textAlign"] = "left";
                // answer["justifyContent"] = "flex-start"
            }
        }
        return answer;
    };
    CvPrintUtil.applyTextAttributes = function (textSize, textAttributes, target) {
        var answer = catavolt_sdk_1.ObjUtil.addAllProps(target, {}); // Do not mutate target
        answer = CvPrintUtil.applyColorStyle(textAttributes.textColor, answer);
        answer = CvPrintUtil.applyTextAlignment(textAttributes, answer);
        answer = CvPrintUtil.applyFontSizeStyle(textSize, textAttributes.numberOfLines, answer);
        answer = CvPrintUtil.applyFontStyle(textAttributes, answer);
        if (textAttributes.numberOfLines > 1) {
            answer["whiteSpace"] = "pre-wrap";
        }
        return answer;
    };
    CvPrintUtil.buildImageProducers = function (readOnly) {
        var imageProducers = null;
        if (!readOnly) {
            imageProducers = [
                {
                    // Pick a new file with the file chooser.
                    prodImageCB: function (listener) { listener(new catreact_1.CvImagePackagePick()); },
                    buttonClassName: CvImage_1.CvImageDefaultAddButtonClass, includeWhenImageisPresent: true, includeWhenImageIsMissing: true,
                    includeWhenImageIsDeleted: true
                },
                {
                    // Delete existing image
                    prodImageCB: function (listener) { listener(new catreact_1.CvImagePackageDelete()); },
                    buttonClassName: CvImage_1.CvImageDefaultRemoveButtonClass, includeWhenImageisPresent: true, includeWhenImageIsMissing: false,
                    includeWhenImageIsDeleted: false
                },
                {
                    // Undo previous delete image
                    prodImageCB: function (listener) { listener(new catreact_1.CvImagePackageUndo()); },
                    buttonClassName: CvImage_1.CvImageDefaultUndoButtonClass, includeWhenImageisPresent: false, includeWhenImageIsMissing: false,
                    includeWhenImageIsDeleted: true
                }
            ];
        }
        return imageProducers;
    };
    CvPrintUtil.componentsAsChildren = function (printBundle, components, fillWidth, fillHeight) {
        var _this = this;
        var answer = [];
        components.map(function (c, index) {
            var h = c.layout.singleHeightRichNum().resolveWithFill(fillHeight);
            var w = c.layout.singleWidthRichNum().resolveWithFill(fillWidth);
            var b = c.binding;
            if (b && b.propertyName) {
                var acd = printBundle.printMarkupDef.orderedCellValueDefs[b.propertyName];
            }
            var pp = { height: h, width: w, left: c.layout.x, top: c.layout.y };
            if (c instanceof catavolt_sdk_2.Label) {
                answer.push(React.createElement(PLabel, { label: c, key: c.id, printBundle: printBundle, positionProps: pp }));
            }
            else if (c instanceof catavolt_sdk_1.Checkbox && b) {
                answer.push(React.createElement(PCheckbox, { checkbox: c, key: c.id, printBundle: printBundle, positionProps: pp }));
            }
            else if (c instanceof catavolt_sdk_2.DatePicker && b) {
                answer.push(React.createElement(PDatePicker, { datePicker: c, key: c.id, printBundle: printBundle, positionProps: pp }));
            }
            else if (c instanceof catavolt_sdk_2.TimePicker && b) {
                answer.push(React.createElement(PTimePicker, { timePicker: c, key: c.id, printBundle: printBundle, positionProps: pp }));
            }
            else if (c instanceof catavolt_sdk_2.SignatureCapture && b) {
                answer.push(React.createElement(PSignatureCapture, { signature: c, attributeCellValueDef: acd, key: c.id, printBundle: printBundle, positionProps: pp }));
            }
            else {
                if (c instanceof catavolt_sdk_2.Component) {
                    if (b && b.propertyName) {
                        var detailsContext = printBundle.printMarkupContext;
                        var detailsCallback = printBundle.detailsCallback;
                        var style = CvPrintUtil.applySizeAndLocationStyle(pp, {});
                        var readOnly = false;
                        // Textish & TextAttributes
                        if (c.textAttributes) {
                            style = CvPrintUtil.applyTextAttributes(c.layout.singleHeightRichNum().resolveWithFill(fillHeight), c.textAttributes, style);
                        }
                        style = CvPrintUtil.applyPaddingStyle(c.padding, style);
                        if (c instanceof catavolt_sdk_2.Image) {
                            // If this is an image, move the width & height to maxWidth & maxHeight and set the width & height
                            // to auto.  This should size and center the image in the space but preserve aspect ratio.
                            style = catavolt_sdk_1.ObjUtil.addAllProps({ objectFit: "contain" }, style);
                        }
                        var imageProducers = null;
                        if (c instanceof catavolt_sdk_2.SignatureCapture) {
                            // Add signature capture here
                        }
                        else if (c instanceof catavolt_sdk_2.Image) {
                            readOnly = !c.allowPickOptions;
                            imageProducers = _this.buildImageProducers(readOnly);
                        }
                        var emptyClassSelector = function (propDef, defaultClass) { return "cv-print-control"; };
                        // const emptyClassSelector = (propDef:PropDef, defaultClass?:string):string => { return "" }
                        var hasFocus = hasInitialFocus(printBundle.printMarkupContext, b.propertyName);
                        answer.push(React.createElement(catreact_html_1.CvAttributeCellValueDef, { detailsContext: detailsContext, detailsCallback: detailsCallback, classSelector: emptyClassSelector, cellValueDef: acd, key: index + '_' + index, imageProducers: imageProducers, inlineStyle: style, imageReadOnly: readOnly, hasFocus: hasFocus }));
                    }
                    else {
                        // Components with no property binding
                        if (c instanceof catavolt_sdk_1.Button) {
                            answer.push(React.createElement(PButton, { button: c, key: c.id, printBundle: printBundle, positionProps: pp }));
                        }
                        else if (c instanceof catavolt_sdk_2.Image) {
                            answer.push(React.createElement(PImage, { image: c, key: c.id, printBundle: printBundle, positionProps: pp }));
                        }
                    }
                }
            }
        });
        return answer;
    };
    CvPrintUtil.gridsAsChildren = function (printBundle, grids, parentSize) {
        var answer = [];
        grids.map(function (g) {
            var h = g.layout.sumOfHeights();
            var w = g.layout.sumOfWidths(parentSize);
            // Add the Grid containing the cells
            var pp = { height: h, width: w, left: g.layout.x, top: g.layout.y };
            answer.push(React.createElement(PGrid, { key: g.id, printBundle: printBundle, grid: g, positionProps: pp, parentSize: parentSize }));
            // Add the grid lines element (draws the grid lines on a canvas)
            answer.push(React.createElement(PGridLines, { key: "GL_gen_" + g.id, printBundle: printBundle, grid: g, positionProps: pp }));
        });
        return answer;
    };
    return CvPrintUtil;
}());
///////////////////////////////////////////////////////////////////////////////
// CvPrintPanel
///////////////////////////////////////////////////////////////////////////////
/**
 * Renders a Details Panel, styled by CSS
 */
exports.CvPrintPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    render: function () {
        var _this = this;
        return React.createElement(catreact_1.CvDetailsPane, __assign({}, this.props, { detailsContext: this.props.printMarkupContext, detailsRenderer: function (cvContext, record, detailsCallback) {
                var printMarkupContext = cvContext.scopeCtx.scopeObj;
                var printMarkupDef = printMarkupContext.printMarkupDef;
                var printMarkupModel = printMarkupDef.printMarkupModel;
                var listeners = { navigationListeners: _this.props.navigationListeners, stateChangeListeners: _this.props.stateChangeListeners,
                    actionListeners: _this.props.actionListeners };
                var printBundle = new PrintBundle(printMarkupDef, printMarkupContext, detailsCallback, listeners);
                return (React.createElement(catreact_1.CvRecord, { entityRec: record, renderer: function (cvContext) {
                        return (React.createElement("div", { className: "cv-component-container cv-detail-container" },
                            (function () {
                                if (printMarkupContext.printMarkupDef.editable) {
                                    if (printMarkupContext.isReadMode) {
                                        return React.createElement("div", { className: "cv-component-toolbar" },
                                            React.createElement(catreact_html_1.CvDetailsPanelControls, { onRefresh: _this._refresh.bind(_this, detailsCallback), onEdit: _this._openWriteMode.bind(_this, detailsCallback) }));
                                    }
                                    else if (printMarkupContext.isWriteMode) {
                                        var cancelButtonText = printMarkupContext.printMarkupDef.cancelButtonText;
                                        var commitButtonText = printMarkupContext.printMarkupDef.commitButtonText;
                                        return React.createElement("div", { className: "cv-component-toolbar" },
                                            React.createElement(catreact_html_1.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, detailsCallback), onCommit: _this._save.bind(_this, detailsCallback) }));
                                    }
                                }
                                else {
                                    return null;
                                }
                            })(),
                            React.createElement("div", { className: "cv-component-body" },
                                React.createElement("div", { className: "cv-component-scroll" },
                                    React.createElement(PForm, { printBundle: printBundle }))),
                            (function () {
                                var cancelButtonText = printMarkupContext.printMarkupDef.cancelButtonText;
                                var commitButtonText = printMarkupContext.printMarkupDef.commitButtonText;
                                return (printMarkupContext.printMarkupDef.editable && printMarkupContext.isWriteMode) ?
                                    React.createElement("div", { className: "cv-component-toolbar" },
                                        React.createElement(catreact_html_1.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, detailsCallback), onCommit: _this._save.bind(_this, detailsCallback) })) : null;
                            })()));
                    } }));
            } }));
    },
    // componentDidMount() {
    //     this.setState({
    //         styles: {
    //             top: computeTopWith(this.refs.child),
    //             left: computeLeftWith(this.refs.child)
    //         }
    //     })
    // },
    _isSectionTitleDef: function (row) {
        return row.every(function (cellDef) {
            return cellDef.values.every(function (cellValueDef) {
                return cellValueDef instanceof catavolt_sdk_1.LabelCellValueDef;
            });
        });
    },
    _cellCount: function (rows) {
        return rows.reduce(function (prev, cellDefRow) {
            var numCellValueDefs = cellDefRow.reduce(function (prev, cellDef) {
                return cellDef.values ? prev + cellDef.values.length : prev;
            }, 0);
            return numCellValueDefs > prev ? numCellValueDefs : prev;
        }, 0);
    },
    _openWriteMode: function (detailsCallback) {
        detailsCallback.openWriteMode(function (success, error) {
        });
    },
    _openReadMode: function (detailsCallback) {
        detailsCallback.openReadMode(function (success, error) {
        });
    },
    _refresh: function (detailsCallback) {
        detailsCallback.refresh();
    },
    _save: function (detailsCallback) {
        detailsCallback.saveChanges(function (success, error) {
        });
    }
});
