"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Created by rburson on 8/11/16.
 */
var React = require("react");
var catreact_1 = require("catreact");
var catreact_html_1 = require("./catreact-html");
var catavolt_sdk_1 = require("catavolt-sdk");
/**
 * Renders a Search Panel, styled by CSS
 */
exports.CvSearchPanel = React.createClass({
    mixins: [catreact_1.CvBaseMixin],
    render: function () {
        var _this = this;
        return React.createElement(catreact_1.CvSearchPane, __assign({}, this.props, { detailsRenderer: function (cvContext, record, searchCallback) {
                var detailsContext = cvContext.scopeCtx.scopeObj;
                return (React.createElement(catreact_1.CvRecord, { entityRec: record, renderer: function (cvContext) {
                        return (React.createElement("div", { className: "cv-detail-container" },
                            (function () {
                                var cancelButtonText = detailsContext.detailsDef.cancelButtonText;
                                var commitButtonText = detailsContext.detailsDef.commitButtonText;
                                return React.createElement(catreact_html_1.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, searchCallback), onCommit: _this._search.bind(_this, searchCallback) });
                            })(),
                            React.createElement("table", { className: "table table-striped" },
                                React.createElement("tbody", null, _this._layoutSearchPane(detailsContext, record, searchCallback))),
                            (function () {
                                var cancelButtonText = detailsContext.detailsDef.cancelButtonText;
                                var commitButtonText = detailsContext.detailsDef.commitButtonText;
                                return React.createElement(catreact_html_1.CvDetailsPanelCommitCancelControls, { cancelButtonText: cancelButtonText, commitButtonText: commitButtonText, onCancel: _this._openReadMode.bind(_this, searchCallback), onCommit: _this._search.bind(_this, searchCallback) });
                            })()));
                    } }));
            } }));
    },
    _isSectionTitleDef: function (row) {
        return row.every(function (cellDef) {
            return cellDef.values.every(function (cellValueDef) {
                return cellValueDef instanceof catavolt_sdk_1.LabelCellValueDef;
            });
        });
    },
    _cellCount: function (rows) {
        return rows.reduce(function (prev, cellDefRow) {
            var numCellValueDefs = cellDefRow.reduce(function (prev, cellDef) {
                return cellDef.values ? prev + cellDef.values.length : prev;
            }, 0);
            return numCellValueDefs > prev ? numCellValueDefs : prev;
        }, 0);
    },
    _layoutSearchPane: function (detailsContext, record, searchCallback) {
        var _this = this;
        var renderedDetailRows = [];
        if (detailsContext) {
            var maxCellCount_1 = this._cellCount(detailsContext.detailsDef.rows);
            detailsContext.detailsDef.rows.forEach(function (cellDefRow, index) {
                var rowCellCount = cellDefRow.reduce(function (prev, cellDef) {
                    return cellDef.values ? prev + cellDef.values.length : prev;
                }, 0);
                renderedDetailRows.push(React.createElement(catreact_html_1.CvDataAnno, { entityRec: record, paneContext: detailsContext, wrapperElem: "tr", wrapperElemProps: { className: "cv-cell-def-row" }, key: index }, (function () {
                    var renderedRow = cellDefRow.map(function (cellDef, i1) {
                        return cellDef.values.map(function (cellValueDef, i2) {
                            //Don't show sort properties here
                            if (!_this._isSortProperty(cellValueDef)) {
                                return React.createElement(catreact_html_1.CvCellValueDef, { detailsContext: detailsContext, detailsCallback: searchCallback, cellValueDef: cellValueDef, wrapperElem: "td", wrapperElemProps: { className: 'cv-cell-def-col' }, key: i1 + '_' + i2 });
                            }
                        });
                    });
                    for (var i = 0; i < maxCellCount_1 - rowCellCount; i++) {
                        renderedRow.push([React.createElement("td", null)]);
                    }
                    return renderedRow;
                })()));
            });
        }
        return renderedDetailRows;
    },
    _getFilterOperatorCellValueDefForRow: function (cellDefRow) {
        var _this = this;
        cellDefRow.reduce(function (prev, cellDef) {
            return cellDef.values.reduce(function (prevVal, cellValueDef) {
                return _this._isFilterOperatorProperty(cellValueDef) ? cellValueDef : null;
            }, null);
        }, null);
    },
    _isFilterOperatorProperty: function (cellValueDef) {
        return (cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef) &&
            (cellValueDef.propertyName.indexOf(catreact_1.FILTER_OPERATOR_SUFFIX) > -1);
    },
    _isFilterValueProperty: function (cellValueDef) {
        return (cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef) &&
            (cellValueDef.propertyName.indexOf(catreact_1.FILTER_VALUE_SUFFIX) > -1);
    },
    _isSortProperty: function (cellValueDef) {
        return (cellValueDef instanceof catavolt_sdk_1.AttributeCellValueDef) &&
            ((cellValueDef.propertyName.indexOf(catreact_1.SORT_DIRECTION_SUFFIX) > -1) ||
                (cellValueDef.propertyName.indexOf(catreact_1.SORT_SEQUENCE_SUFFIX) > -1));
    },
    _openReadMode: function (searchCallback) {
        searchCallback.openReadMode(function (success, error) {
        });
    },
    _search: function (searchCallback) {
        searchCallback.submitSearch(function (success, error) {
        });
    }
});
