/// <reference types="react" />
/**
 * Created by rburson on 3/21/16.
 */
import * as React from 'react';
import { CvState, CvProps, CvDetailsPaneCallback, CvImageExistenceState, CvImageProducer } from 'catreact';
import { PropDef, CellValueDef, EditorContext } from 'catavolt-sdk';
export interface CvCellValueDefState extends CvState {
}
export interface CvCellValueDefProps extends CvProps {
    cellValueDef: CellValueDef;
    detailsContext?: EditorContext;
    detailsCallback?: CvDetailsPaneCallback;
    imageProducers?: Array<CvImageProducer>;
    imageReadOnly?: boolean;
    wrapperElem: any;
    wrapperElemProps?: any;
    overrideDefaultValue?: string;
    valueChangeListener?: (propName: string, propDef: PropDef, newValue: any) => void;
}
export declare let CvCellValueDefMixin: {
    _applyHeaderStyle(component: any, cellValueDef: CellValueDef): any;
    cellValueDef: (nextProps: any) => any;
    detailsCallback: (nextProps: any) => any;
    detailsContext: (nextProps: any) => any;
    getChildContext: () => any;
};
export declare let CvCellValueDef: React.ClassicComponentClass<CvCellValueDefProps>;
export interface CvAttributeCellValueDefState extends CvCellValueDefState {
    availableValues?: Array<any>;
    selectedImageSrc?: string;
    imageExistenceState: CvImageExistenceState;
    imageUndoData: any;
}
export interface CvAttributeCellValueDefProps extends CvProps {
    cellValueDef: CellValueDef;
    detailsContext?: EditorContext;
    detailsCallback?: CvDetailsPaneCallback;
    imageProducers?: Array<CvImageProducer>;
    imageReadOnly?: boolean;
    inlineStyle?: {};
    overrideText?: string;
    overrideDefaultValue?: string;
    valueChangeListener?: (propName: string, propDef: PropDef, newValue: any) => void;
    classSelector?: (propDef: PropDef, defaultClass?: string) => string;
    hasFocus?: boolean;
}
export declare let CvAttributeCellValueDef: React.ClassicComponentClass<CvAttributeCellValueDefProps>;
