/// <reference types="react" />
/**
 * Created by rburson on 3/18/16.
 */
import * as React from 'react';
import { CvActionFiredResult, CvState, CvProps, CvNavigationResult, CvStateChangeResult, CvEvent, CvValueProvider, CvActionHandlerParams } from 'catreact';
import { FormContext, DetailsContext } from 'catavolt-sdk';
export interface CvDetailsPanelState extends CvState {
}
/**
 * Details Panel Properties
 */
export interface CvDetailsPanelProps extends CvProps {
    formContext?: FormContext;
    paneRef?: number;
    detailsContext?: DetailsContext;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
}
/**
 * Renders a Details Panel, styled by CSS
 */
export declare let CvDetailsPanel: React.ClassicComponentClass<CvDetailsPanelProps>;
export declare let CvDetailsPanelCommitCancelControls: React.ClassicComponentClass<{
    cancelButtonText: string;
    commitButtonText: string;
    onCancel: () => {};
    onCommit: () => {};
}>;
export declare let CvDetailsPanelControls: React.ClassicComponentClass<{
    onRefresh: () => {};
    onEdit: () => {};
}>;
