/// <reference types="react" />
/**
 * Created by rburson on 4/27/16.
 */
import * as React from 'react';
import { CvState, CvProps, CvNavigationResult, CvEvent, CvStateChangeResult, CvValueProvider, CvValueListener, CvActionHandlerParams, CvActionFiredResult } from 'catreact';
import { FormContext, GraphContext, GraphDef, GraphDataPointDef } from 'catavolt-sdk';
export declare const CvChart: {
    axisType: (graphContext: GraphContext, propName: string, data: any[]) => "number" | "category";
    colorForDataPointDef: (dataPointDef: GraphDataPointDef, i: number) => any;
    getMetaValues: (graphDef: GraphDef, data: any[]) => {
        minX: number;
        maxX: string | number;
        minY: number;
        maxY: string | number;
        xAxisLabel: string;
        yAxisLabel: string;
    };
    handleClick(id: any): void;
    _applyAlpha: (c: any, a: number) => string;
    _getSampleValue(data: any[], name: string): any;
    _zeroFill(color: string): string;
};
export interface CvChartProps extends CvProps {
    graphContext: GraphContext;
    data: Array<any>;
    identPropName: string;
    defaultSeriesColors: Array<string>;
    clickHandler: (id: string) => void;
}
export declare const CvLineChart: React.ClassicComponentClass<CvChartProps>;
export interface CvBarChartProps extends CvChartProps {
    stack?: boolean;
}
export declare const CvBarChart: React.ClassicComponentClass<CvBarChartProps>;
export interface CvScatterChartProps extends CvChartProps {
    bubble?: boolean;
}
export declare const CvScatterChart: React.ClassicComponentClass<CvScatterChartProps>;
export interface CvPieChartProps extends CvChartProps {
}
export declare const CvPieChart: React.ClassicComponentClass<CvPieChartProps>;
export interface CvGraphPanelState extends CvState {
}
export interface CvGraphPanelProps extends CvProps {
    paneRef?: number;
    formContext?: FormContext;
    graphContext: GraphContext;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    selectionListener?: CvValueListener<Array<string>>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    navTarget?: string;
    defaultSeriesColors?: Array<string>;
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
}
export declare const CvGraphPanel: React.ClassicComponentClass<CvGraphPanelProps>;
export interface CvGraphState extends CvState {
}
export interface CvGraphProps extends CvProps {
    graphContext: GraphContext;
    lastRefreshTime: Date;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    selectionListener?: CvValueListener<Array<string>>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    navTarget?: string;
    defaultSeriesColors?: Array<string>;
}
export declare const CvGraph: React.ClassicComponentClass<CvGraphProps>;
