/// <reference types="react" />
/**
 * Created by rburson on 3/15/16.
 */
import * as React from 'react';
import { CvState, CvProps, CvEvent, CvNavigationResult, CvValueProvider, CvActionFiredResult } from 'catreact';
import { Workbench, AppWinDef } from 'catavolt-sdk';
export interface CvGraphicalWorkbenchState extends CvState {
    workbench?: Workbench;
}
export interface CvGraphicalWorkbenchProps extends CvProps {
    /**
     * The sdk {AppWinDef} from which to retrieve the workbenches
     */
    appWinDef?: AppWinDef;
    /**
     * Register to receive {@link CvEvent}s of type {@link CvNavigationResult}
     */
    launchListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    /**
     * Register to receive {@link CvEvent}s of type {@link CvActionFiredResult}
     */
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    /**
     * The workbench id of the workbench to show.
     * Should not be used if the workbench property is provided
     */
    workbenchId?: string;
    /**
     * The workbench to show
     * Should not be used if the workbenchId property is provided
     */
    workbench?: Workbench;
    /**
     * Number of columns to use for the workbench launcher display
     */
    numCols?: number;
    /**
     * A workbench selection provider, to which this component will 'listen' and display workbench selection changes
     */
    selectionProvider?: CvValueProvider<Workbench>;
}
export declare var CvGraphicalWorkbench: React.ClassicComponentClass<CvGraphicalWorkbenchProps>;
export interface CvGraphicalWorkbenchPanelState extends CvState {
}
export interface CvGraphicalWorkbenchPanelProps extends CvProps {
    /**
     * The sdk {AppWinDef} from which to retrieve the workbenches
     */
    appWinDef?: AppWinDef;
    /**
     * The workbench id of the workbench to show.
     * Should not be used if the workbench property is provided
     */
    workbenchId: string;
    /**
     * Function that renders the given workbench
     */
    workbenchRenderer: (workbench: Workbench) => {};
}
export declare var CvGraphicalWorkbenchPanel: React.ClassicComponentClass<CvGraphicalWorkbenchPanelProps>;
