/// <reference types="react" />
/**
 * Created by rburson on 3/18/16.
 */
/**
 *  Warning!  This component required 'wrapping' a non-React style, traditional javascript grid component (ag-grid)
 *  The wrapped component is very stateful and requires interaction and control with a very 'imperative' javascript api,
 *  thus this component is not a good example the stateless, functional components that React normally promotes.
 *  There has been much work done here to 'work around' the issues created by the grid component and it's requirements.
 *  i.e. the grid component does not gracefully survive React component updates.
 *
 */
import * as React from 'react';
import { CvState, CvProps, CvNavigationResult, CvEvent, CvQueryPaneCallback, CvValueListener, CvStateChangeResult, CvActionFiredResult, CvValueProvider, CvActionHandlerParams, CvSearchPaneCallback, CvEventRegistry } from 'catreact';
import { FormContext, ListContext } from 'catavolt-sdk';
export declare enum CvGridEventType {
    SELECTION_EVENT = 0,
    TOTAL_ROWS_LOADED_EVENT = 1,
    FIRST_VISIBLE_ROW_CHANGE_EVENT = 2,
}
export interface CvGridEvent<T> {
    type: CvGridEventType;
    eventObj: T;
}
export interface CvGridPanelState extends CvState {
    searchNavEvent: CvEvent<CvNavigationResult>;
    quickFilterNavResult: CvNavigationResult;
    complexSearchNavResult: CvNavigationResult;
    numInitialRows: number;
    initialFirstVisibleRow: number;
}
export interface CvGridPanelProps extends CvProps {
    paneRef?: number;
    formContext?: FormContext;
    listContext?: ListContext;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    gridListener?: CvValueListener<CvGridEvent<any>>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
    searchable?: boolean;
    initialSelectedItems?: Array<string>;
    numInitialRows?: number;
    initialFirstVisibleRow?: number;
    gridHeight?: string;
}
export declare var CvGridPanel: React.ClassicComponentClass<CvGridPanelProps>;
export declare var CvQuickFilter: React.ClassicComponentClass<{
    filterValueListener: CvValueListener<string>;
}>;
export interface CvGridTableState extends CvState {
    numInitialRows: number;
    initialFirstVisibleRow: number;
    initialSelectedItems: Array<string>;
    forceAutoSize: boolean;
}
export interface CvGridTableProps extends CvProps {
    listContext: ListContext;
    lastRefreshTime: Date;
    initialSelectedItems?: Array<string>;
    numInitialRows?: number;
    gridHeight?: string;
    initialFirstVisibleRow?: number;
    queryPaneCallback: CvQueryPaneCallback;
    searchNavResult: CvNavigationResult;
    quickFilterCallback: CvSearchPaneCallback;
    eventRegistry: CvEventRegistry;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    gridListener?: CvValueListener<CvGridEvent<any>>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
}
export declare var CvGridTable: React.ClassicComponentClass<CvGridTableProps>;
export declare var CvGridTableCellColumn0: React.ClassicComponentClass<{}>;
export declare var CvGridTableCell: React.ClassicComponentClass<{}>;
