/// <reference types="react" />
/**
 * Created by rburson on 1/14/16.
 */
import * as React from 'react';
import { Prop, EntityRec, PaneContext } from 'catavolt-sdk';
import { CvProps, CvImageAction } from 'catreact';
export interface CvHtmlPropProps extends CvProps {
    /**
     * className to apply to the property.  wrapperElemProps will override this value
     */
    className?: string;
    /**
     * style to apply to the property.  wrapperElemProps will override this value
     */
    style?: {};
    handler?: (o: Prop) => {};
    /**
     * Function that allows for visibility control.  Accepts sinlge param of sdk {Prop} object.  Should return true
     * if the component should be rendered, false if the component should be hidden.
     */
    isVisible?: (o: Prop) => boolean;
    /**
     * The name of this property.  The given (or enclosing) sdk {EnityRec} will be searched for the sdk {Prop} of this name
     */
    propName: string;
    /**
     * Default to be used if this sdk {Prop} value is null or undefined
     */
    defaultValue?: string;
    /**
     * The sdk {EntityRec} that owns this sdk {Prop}
     */
    entityRec?: EntityRec;
    /**
     * The containing PaneContext
     */
    paneContext?: PaneContext;
    /**
     * The wrapper element name for this prop value (should be html)
     */
    wrapperElemName?: string;
    /**
     * The wrapper element props
     */
    wrapperElemProps?: any;
    /**
     * Force the value of this prop to be the given value
     */
    overrideValue?: string;
    /**
     * The className to apply to 'bool' true values
     */
    boolTrueClassName?: string;
    /**
     * The className to apply to 'bool' false values
     */
    boolFalseClassName?: string;
    /**
     * The actions available for images
     */
    imageActions?: Array<CvImageAction>;
    /**
     * The className to apply to image elements
     */
    imageClassName?: string;
    /**
     * The style to apply to image elements
     */
    imageStyle?: {};
    /**
     * Is the image control read only or maintainable.  Used to allow class name annotating.
     */
    imageReadOnly?: boolean;
    /**
     * Should the image control automatically fire the single image action.
     */
    hasFocus?: boolean;
    /**
    * Set the named properties' values to the property's final resolved value
    * i.e. 'title' on an html element for a tooltip
    */
    dataPropNames?: Array<string>;
}
export declare let CvHtmlProp: React.ClassicComponentClass<CvHtmlPropProps>;
