/// <reference types="react" />
/**
 * Created by rburson on 4/27/16.
 */
import * as React from 'react';
import { CvState, CvProps, CvNavigationResult, CvEvent, CvValueListener, CvStateChangeResult, CvActionFiredResult, CvValueProvider, CvActionHandlerParams } from 'catreact';
import { FormContext, MapContext } from 'catavolt-sdk';
export interface CvMapPanelState extends CvState {
}
export interface CvMapPanelProps extends CvProps {
    paneRef?: number;
    formContext?: FormContext;
    mapContext?: MapContext;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    selectionListener?: CvValueListener<Array<string>>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    navTarget?: string;
    containerProps?: {};
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
}
export declare var CvMapPanel: React.ClassicComponentClass<CvMapPanelProps>;
export interface CvMapState extends CvState {
    openMarker: CvMarker;
    currentSelection: CvMarker;
    previousSelection: CvMarker;
    openMenu: {};
    directions: {};
    persistentMarkers: Array<CvMarker>;
    searchMarkers: Array<CvMarker>;
    userMarkers: Array<CvMarker>;
}
export interface CvMapProps extends CvProps {
    paneRef?: number;
    formContext?: FormContext;
    mapContext?: MapContext;
    lastRefreshTime?: Date;
    navigationListeners?: Array<(event: CvEvent<CvNavigationResult>) => void>;
    selectionListener?: CvValueListener<Array<string>>;
    stateChangeListeners?: Array<(event: CvEvent<CvStateChangeResult>) => void>;
    actionListeners?: Array<(event: CvEvent<CvActionFiredResult>) => void>;
    navTarget?: string;
    actionProvider?: CvValueProvider<CvActionHandlerParams>;
}
export interface CvMarker {
    id: string;
    lat: number;
    lng: number;
    desc: string;
    imgUrl?: string;
    tipText?: string;
    imagePlc?: string;
    draggable?: boolean;
}
