/// <reference types="react" />
/**
 * Prompt with some text and some actions buttons.
 */
import * as React from 'react';
import { CvState, CvProps } from 'catreact';
export declare function promptOpenUrl(url: string): void;
export declare function openPopupPrompt(title: string, message: string, buttonTexts: string[], actions: (() => void)[], containerClass?: string, buttonClass?: string): void;
export interface CvPopupPromptState extends CvState {
    popupActive: boolean;
    title: string;
    message: string;
    buttonTexts: string[];
    actions: string[];
}
export interface CvPopupPromptProps extends CvProps {
    title?: string;
    message?: string;
    buttonTexts?: string[];
    actions?: (() => void)[];
}
/**
 Component that overlays a signature popup.
 */
export declare const CvPopupPrompt: React.ClassicComponentClass<CvPopupPromptProps>;
