/// <reference types="react" />
/**
 * Created by rburson on 3/16/16.
 */
import * as React from 'react';
import { CvState, CvProps, CvValueProvider } from 'catreact';
import { AppWinDef, Workbench } from 'catavolt-sdk';
export interface CvWorkbenchManagerState extends CvState {
    activeWorkbench: Workbench;
}
export interface CvWorkbenchManagerProps extends CvProps {
    /**
     * The sdk {AppWinDef} from which to retrieve the workbenches
     */
    appWinDef?: AppWinDef;
    /**
     * A renderer for the workbench menu.  Should return a 'renderable'
     */
    menuRenderer: () => {};
    /**
     * A renderer for the workbench.  Should return a 'renderable'
     * @param intialWorkbench
     */
    workbenchRenderer: (intialWorkbench: Workbench) => {};
    /**
     * A workbench selection provider, to which this component will 'listen' and display workbench selection changes
     */
    selectionProvider: CvValueProvider<Workbench>;
}
export declare var CvWorkbenchManager: React.ClassicComponentClass<CvWorkbenchManagerProps>;
